#!/usr/bin/env python2
# -*- coding: latin1 -*-

##
## This is NOT the correct place to put this information.
## I put it here anyway :)
##
##
# If you are starting to get "TEST_BAYESIAN exceptions.AssertionError"
#
# It seems that spambayes classifier is trying to use too small number as
# "nspam" (or nham). I did some research and testing, and find out that
# quickfix below is working just fine:
#
# /usr/lib/python2.3/site-packages/spambayes/classifier.py
# Row: 313
# Original:	assert hamcount <= nham, "Token seen in more ham than ham trained."
# Modified:	assert hamcount <= max(nham, hamcount), "Token seen in more ham than ham trained."
#
# Row: 316
# Original:	assert spamcount <= nspam, "Token seen in more spam than spam trained."
# Modified:	assert spamcount <= max(nspam, spamcount), "Token seen in more spam than spam trained."
#

"""Semi's SPAM Milter - Get rid of E-mail spams and viruses.
(virus scanner not included)
"""

__author__ = "Sami-Pekka Hallikas <semi@hallikas.com>"
__email__ = "semi@hallikas.com"
__date__ = "05 May 2010"
__version__ = "2.8"

import traceback
import sys
import os
import re
import signal
import thread
import time
import calendar
import commands
import base64
import email
import htmllib, formatter, urllib, string
import anydbm
import ConfigParser
import mime
import locale

# http://sourceforge.net/projects/pymilter
import Milter
import DNS
import spf
#
# http://sourceforge.net/projects/mysql-python
#import MySQLdb
#
# rpmforge repository:
import rrdtool
#
# http://spambayes.sourceforge.net/
from spambayes import hammie

# Debug
from syslog import LOG_ERR, LOG_WARNING, LOG_NOTICE, LOG_INFO, LOG_DEBUG, LOG_MAIL, LOG_PID, LOG_CONS
import syslog
#import traceback
#import profile

locks = {}
loglines = []
statlines = []
conffile = "sspamm.conf"
globaltmp = {}

##
## Defaults for config
##
confdefs = {
	"main": {
		"name":			"sspamm",
		"port":			"inet:7999",
		"tmpdir":		"/dev/shm",
		"sspammdir":		"",
		"pid":			"sspamm.pid",
		"logfile":		"sspamm.log",
		"syslog":		False,
		"watchmode":		False,
		"debugfile":		"debug.log",
		"verbose":		False,
		"detailed":		False,
		"timeme":		True,
		"savedir":		"",
	},
	"stats": {
		"driver":		None,
		"user":			"sspamm",
		"pass":			"sspamm",
		"host":			"localhost",
		"database":		"sspamm2",
		"table":		"stats",
	},
	"filter": {
		"tests":		["connect", "helo", "ipfromto", "charset", "headers", "wordscan", "rbl", "dyndns", "bayesian"],
		"domains":		[],
		"rules":		[],
	},
	"connect": {
		"action":		"Flag",
		"ignore_ip":		["127.0.0.1"],
		"ignore_dns":		[],
		"allow_ip":		[],
		"allow_dns":		[],
		"block_ip":		[],
		"block_dns":		[]
	},
	"helo": {
		"action":		"Flag",
		"recursive":		False,
		"rules":		[],
	},
	"samefromto": {
		"action":		"Flag",
	},
	"rbl": {
		"action":		"Flag",
		"recursive":		False,
		"ipservers":		["sbl-xbl.spamhaus.org", "dnsbl.sorbs.net", "bl.spamcop.net"],
		"skip_ip":		[],
		"skip_dns":		[],
	},
	"dyndns": {
		"action":		"Flag",
		"recursive":		False,
		"ignore_authmx":	[],
		"known_authmx":		[],
		"skip_dyndns":		[],
		"rules":		[
					"^[0-9]{1,3}[\-\.][0-9]{1,3}[\-\.][0-9]{1-3}\..*",
		],
	},
	"bayesian": {
		"action":		"Flag",
		"unsure":		"Flag",
		"spampros":		90,
		"hampros":		20,
		"maxbodysize":		200,
		"commondb":		"sspamm.db",
		"mimeparts":		False,
		"usedomaindb":		False,
		"dbtrain":		False,
		"savembox":		False,
		"saveunsure":		True,
		"maxtrainsize":		512,
		"msgsneeded":		10,
		"maxtrain":		10000,
		"ratio":		"50:50",
	},
	"accept": {
		"rules":		[],
	},
	"block": {
		"rules":		[],
	},
	"ipfromto": {
		"action":		"Flag",
		"maxrcpt":		2,
		"rules":		[],
	},
	"headers": {
		"action":		"Flag",
		"rules":		[],
	},
	"charset": {
		"action":		"Flag",
		"rules":		[],
	},
	"wordscan": {
		"action":		"Flag",
		"maxbodysize":		200,
		"links":		[],
		"blockhtml":		[],
		"subject":		[],
		"blockwords":		[],
	},
}
conf = confdefs.copy()
conf["runtime"] = {
	"starttime": 0,
	"endtime": 0,
	"conftime": 0,
	"logtime": 0,
	"offline": False,
	"syslog": False,
}

##
## CONFIGURATION
##
class MyParser(ConfigParser.ConfigParser):
	def getlines(self,section,option,default=None):
		try:
			value = self.get(section, option)
			t = value.split('\n')
			try:
				if t[0] == "": t.remove('')
			except IndexError:
				t = []
			return t
		except ConfigParser.NoOptionError, (err):
			print err
			pass
		except:
			print "Warning: No value for %s: %s" % (section, option)
			return None
		return default

	def getlist(self,section,option,default=None):
		try:
			value = self.get(section, option)
			(value, count) = re.compile(",|;|\n").subn(' ', value)
			t = value.split()
			try:
				if t[0] == "": t.remove('')
			except IndexError:
				t = []
			return t
		except ConfigParser.NoOptionError, (err):
			print err
			pass
		except:
			print "Warning: No value for %s: %s" % (section, option)
			return None
		return default

def config_read(cfgfile = "/etc/sspamm.conf"):
	tmpconf = conf.copy()
	cp = MyParser()
	if not os.access(cfgfile, os.R_OK):
		print "FATAL: Can't access %s." % (cfgfile)
		return
	cp.read(cfgfile)

	if not (cp.has_section("main")):
		print "FATAL: Main section is missing!"

	try:
		conf["main"]["verbose"] = cp.getboolean("main", "verbose")
	except:
		try:
			conf["main"]["verbose"] = cp.getint("main", "verbose")
		except:
			pass
		pass

	for s in confdefs.keys():
		if cp.has_section(s):
			for k in confdefs[s].keys():
				try:
					if "%s/%s" % (s,k) in ["filter/domains"]:
						t = []

						for i in cp.getlines(s, k, []):
							i=re.sub("\t| ", "", i).split(":")
							if '' in i: i.remove('')
							if len(i) == 1: i.append("all")
							t.append((i[0].split(","), i[1].split(",")))
						tmpconf[s][k] = t

					elif "%s/%s" % (s,k) in ["filter/rules"]:
						t = []

						for i in cp.getlines(s, k, []):
							i=re.sub("\t| ", "", i).split(":")
							if '' in i: i.remove('')
							if len(i) > 1:
								t.append((i[0].split(","), ":".join(i[1:]).split(",")))
						tmpconf[s][k] = t

					# Parameters that can be bolean value
					elif k in ["enabled", "verbose", "detailed", "watchmode", "syslog", "timeme", "recursive", "usedomaindb", "dbtrain", "savembox", "saveunsure", "mimeparts", "learning"]:
						try:
							tmpconf[s][k] = cp.getboolean(s, k)
						except ValueError:
							tmpconf[s][k] = cp.getint(s, k)
					# RegExp lines
					elif k in ["links", "blockhtml", "blockwords", "subject"]:
						testconf = []
						tmpconf[s][k] = cp.getlines(s, k, tmpconf[s][k])
						for t in tmpconf[s][k]:
							if dumbregtest(t): testconf.append(t)
						tmpconf[s][k] = testconf
					elif "%s/%s" % (s,k) in [ "headers/rules", "helo/rules" ]:
						testconf = []
						tmpconf[s][k] = cp.getlines(s, k, tmpconf[s][k])
						for t in tmpconf[s][k]:
							if dumbregtest(t): testconf.append(t)
						tmpconf[s][k] = testconf
					elif type(tmpconf[s][k]) is int:
						try:
							tmpconf[s][k] = cp.getint(s, k)
						except ValueError:
							debug("%s/%s should be numerical! Using default value %s" % (s, k, tmpconf[s][k]), LOG_ERR)
					elif type(tmpconf[s][k]) is list:
						tmpconf[s][k] = cp.getlist(s, k, tmpconf[s][k])
					else:
						tmpconf[s][k] = cp.get(s, k)
				except ConfigParser.NoOptionError, (err):
					if "%s/%s" % (s,k) in [ "main/pid" ]:
						tmpconf[s][k] = confdefs[s][k]
					elif "%s/%s" % (s,k) in [ "main/sspammdir", "main/timeme", "main/syslog", "stats/driver", "main/debugfile", "main/logfile", "main/savedir", "bayesian/commondb", "wordscan/blockhtml" ]:
						tmpconf[s][k] = None
					else:
						debug("%s" % err, LOG_ERR)
				if tmpconf[s][k] == "None":
					tmpconf[s][k] = None
				else:
					# Write 'our special regexp' (_ip and _dns) to real regexp
					# Notice, even SPACE is rule separator!
					if "%s/%s" % (s,k) in [ "accept/rules", "block/rules", "ipfromto/rules" ]:
						testconf = []
						for t in tmpconf[s][k]:
							if dumbregtest(t): testconf.append(t)
						tmpconf[s][k] = testconf
					elif "%s/%s" % (s,k) in [ "connect/allow_ip", "connect/allow_dns", "connect/block_ip", "connect/block_dns", "rbl/skip_ip", "rbl/skip_dns", "dyndns/skip_ip", "dyndns/skip_dns" ]:
						testconf = []
						for t in tmpconf[s][k]:
							if "%s/%s" % (s,k) in [] or ("%s/%s" % (s,k))[-3:] == "_ip":
								t = re.sub("^", "^", re.sub("\?", ".", re.sub("\.", "\.", t)))
							elif "%s/%s" % (s,k) in ["dyndns/rules"] or ("%s/%s" % (s,k))[-4:] == "_dns":
								t = re.sub("$", "$", re.sub("\*", ".*", re.sub("\?", ".", re.sub("\.", "\.", t))))
							if dumbregtest(t): testconf.append(t)
						tmpconf[s][k] = testconf
		else:
			if s != "runtime":
				debug("Section %s not found" % s, LOG_ERR)
				del tmpconf[s]

# Now config is fully loaded, do some special parsing.
	tmp = []
	for val in tmpconf["filter"]["domains"]:
		retests = val[1]
		if 'all' in val[1]:
			retests += tmpconf["filter"]["tests"]
			retests.remove('all')
		else:
			retests = val[1]
		if '' in retests: retests.remove('')

		tests = []
		rules = 0
		action = {}
		for test in retests:
			if test in tests: continue
			tests.append(test)
			if test[0] >= 'a' and test[0] <= 'z':
				rules += 1

		if rules == 0:
			tests += tmpconf["filter"]["tests"]
		if 'all' in tests: tests.remove('all')
		t = list(tests)
		for test in tests:
			if test[0] == "-" or test[0] == "!":
				if test[1:] in t: t.remove(test[1:])
				t.remove(test)
			if test[0] == "+":
				if test[1:] in t: t.remove(test[1:])
				t.remove(test)
				t.append(test[1:])
			
		tmp.append((val[0], t))
	tmpconf["filter"]["domains"] = tmp
#	print show_vars(tmp)

	tmp = {}
	for val in tmpconf["filter"]["rules"]:
		for domain in val[0]:
			if not tmp.has_key(domain): tmp[domain] = {}
			for rule in val[1]:
				r = rule.split('=')
				if len(r) > 2:
					test=r[0].lower()
					param="=".join(r[1:])
				elif len(r) == 2:
					test=r[0].lower()
					param=r[1]
				else:
					test="rules"
					param=r[0]
				if test == "rules":
					if not tmp[domain].has_key(test): tmp[domain][test] = []
					tmp[domain][test].append(param)
				else:
					tmp[domain][test] = param
	tmpconf["filter"]["rules"] = tmp
	return tmpconf;

def dumbregtest(regrule):
	try:
		test = re.search(regrule, "The quick brown fox jumps over the lazy dog.\n\t1234567890@${[]}!#&/()=*+-_,;:", re.IGNORECASE+re.MULTILINE)
		if test:
			debug("regexp error: Matched too easily: %s" % (regrule), LOG_ERR)
			return False
	except:
		debug("regexp error: %s: %s" % (sys.exc_value, regrule), LOG_ERR)
		return False
	return regrule

def config_save():
	fp = open("%s.bak" % conffile, "w+b")
	tmpconf = conf.copy()
	del tmpconf["runtime"]
	fp.write(show_vars(tmpconf))
	fp.close()

def sig_reload(signal=None, frame=None):
	conf["runtime"]["sighup"] = True
	if "sighup" not in loglines: loglines.append("sighup")

def config_load(file):
	global conf

	try:
		conf = config_read(file);
		if conf["main"]["syslog"]:
			conf["runtime"]["syslog"] = True
			syslog.openlog(conf["main"]["name"],LOG_PID|LOG_CONS, LOG_MAIL)
		elif conf["runtime"]["syslog"] == True:
			conf["runtime"]["syslog"] = False
			syslog.closelog()
	except:
		debug("CONFIG LOAD ERROR. %s: %s" % (sys.exc_type, sys.exc_value), LOG_ERR)
		traceback.print_exc(limit=None, file=sys.stderr)



##
## DEBUG
##
def debug(args, level=LOG_DEBUG, id=None, trace=None):
	global conf

	verb = int(conf["main"]["verbose"])+5
	
	if level == LOG_ERR: pass
	elif verb <= level: return

	datetime = ""
	msg = ""
	if not conf["runtime"]["offline"]:
		datetime = time.strftime('%Y%m%d %H:%M:%S')+" "
	if id:
		if conf["main"]["savedir"]:
			msg += "[%08d] " % (int(id))
		else:
			msg += "(%08d) " % (int(id))
	if conf["runtime"]["syslog"]:
		syslog.syslog(level,msg+args)
	if not id:
		msg += "%8s " % ("")
	msg = str(msg) + str(args)
	msg = datetime + msg
	if not conf["main"]["debugfile"] or conf["runtime"]["offline"]:
		print msg
	elif level == LOG_ERR:
		print msg
	if trace:
		traceback.print_exc(limit=None, file=sys.stderr)
	sys.stdout.flush()
	if not conf["runtime"]["offline"] and conf["main"]["debugfile"] and verb > 0:
		reopen = True
		try:
			if debugfile: reopen = None
		except:
			reopen = True
		while True:
			if reopen:
				try: debugfile.close()
				except: pass
				try:
					debugfile = open(conf["main"]["debugfile"], "a")
				except:
					print "%s: %s (debug, open file)" % (sys.exc_type, sys.exc_value)
					conf["main"]["debugfile"] = None
					break
			if debugfile.name != conf["main"]["debugfile"]:
				reopen = True
			try:
				debugfile.write(msg+"\n")
				debugfile.flush()
			except:
				reopen = True
				continue
			break
	try: debugfile.close()
	except: pass
	return

def save_vars(var, fname, id=None):
	if conf["runtime"]["offline"]: return
	debug("save_vars(\"%s\")" % (fname), LOG_DEBUG, id=id)
	fp = open(fname, "w+b")
	if fp: fp.write(show_vars(var))
	fp.close()

def load_vars(fname):
	debug("load_vars(\"%s\")" % fname)
	fp = open(fname, "r")
	is_raw = False
	do_skip = False
	buf = ""
	while 1:
		line = fp.readline()
		if len(line) < 1: break
		if line[1:10] == "\"mime\": {":
			do_skip = True
		if line[1:13] == "\"raw\": 'From":
			raw = line[9:]
			is_raw = True
		elif is_raw:
			if line == "',\n":
				is_raw = False
			else:
				raw += line
		elif do_skip:
			if line[1:3] == "},":
				do_skip = False
			pass
		else:
			buf += line
	fp.close()
	vars = eval(buf)
	vars["raw"] = raw
	return vars

def show_vars(var, lvl=0):
	if lvl==0: lvl=1
	st=""
	tab = "\t"

	if type(var) is dict:
		st += "{\n"
		for k in var.keys():
			st += tab*lvl
			if(0): # Reserve space for keys
				if type(k) is int:
					st += "%-16s" % ("%d: " % k)
				else:
					st += "%-16s" % ("\"%s\": " % k)
			else:
				if type(k) is int:
					st += "%d: " % k
				else:
					st += "\"%s\": " % k
			st += show_vars(var[k], lvl+1)
			st += ",\n"
		st += tab*(lvl-1)
		st += "}"
	elif type(var) is tuple:
		if len(var) < 1:
			st += str(var)
		else:
			st += "(\n"
			for k in var:
				st += tab*lvl
				st += show_vars(k, lvl+1)
				st += ",\n"
			st += tab*(lvl-1)
			st += ")"
	elif type(var) is list:
		if len(var) < 1:
			st += str(var)
		elif len(var) == 1 and type(var[0]) in [str, int]:
			st += str(var)
		else:
			st += "[\n"
			for k in var:
				st += tab*lvl
				st += show_vars(k, lvl+1)
				st += ",\n"
			st += tab*(lvl-1)
			st += "]"
	elif type(var) is str:
		st += "\'%s\'" % re.sub("\'", "\\\'", var)
	elif type(var) is int:
		st += "%d" % var
	elif var == None:
		st += "None"
	else:
		st += str(var)
	return st

def uniq(seq, idfun=None): 
	# order preserving
	if idfun is None:
		def idfun(x): return x
	seen = {}
	result = []
	for item in seq:
		if item == None: continue
		marker = idfun(item)
		# in old Python versions:
		# if seen.has_key(marker)
		# but in new ones:
		if marker in seen: continue
		seen[marker] = 1
		result.append(item)
	return result

def do_lock(file, unlock=False, id=None):
	lockname = "%s.%s" % (file, id)
	if unlock == True:
		debug("do_(un)lock(\"%s\")" % (file), id=id)
		rm("%s.lck" % (lockname))
		try:
			del locks[lockname]
		except:
			debug("%s: %s (do lock)" % (sys.exc_type, sys.exc_value), LOG_ERR)
		return
	debug("do_lock(\"%s\")" % (file), id=id)
	t = time.time()
	while (file in locks) or (os.path.exists("%s.lck" % (lockname))):
		if (time.time()-t) > 5:
			debug("\tLocking timeout (%s)" % (file), LOG_NOTICE, id=id)
			return
		pass

	locks[lockname] = True
	fp = open("%s.lck" % (lockname), "w+b")
	fp.write("%s\n" % os.getpid())
	fp.close()
	debug("\tLocked %s" % (file), id=id)
	return True

def domainrule(mail, key, default=None):
	if not mail["rules"]: return default
	try:
		if mail["rules"].has_key(key):
			return mail["rules"][key]
		if mail["rules"].has_key("rules"):
			if key in mail["rules"]["rules"]: return True
			if '!'+key in mail["rules"]["rules"]: return False
	except:
		debug("%s: %s (domainrule)" % (sys.exc_type, sys.exc_value), LOG_ERR)
	return default

def stripUnprintable(input_string):
	try: filterUnprintable = stripUnprintable.filter
	except AttributeError: # only the first time it is called
		allchars = string.maketrans('','')
		delchars = allchars.translate(allchars, string.letters+string.digits+string.punctuation+string.whitespace)
		filterUnprintable = stripUnprintable.filter = lambda input: input.translate(allchars, delchars)
	return filterUnprintable(input_string)

##
## Basic fileoperations (Usualy we don't need to care if it success or not)
##
def mkdir(path):
	debug("mkdir(\"%s\")" % path)
	try:
		os.mkdir(path)
	except OSError, (errno, strerror):
		if errno != 17:
			debug("%s" % sys.exc_value, LOG_ERR)
	except:
		debug("%s: %s" % (sys.exc_type, sys.exc_value), LOG_ERR)

def rmdir(path, id=None):
	debug("rmdir(\"%s\")" % (path), LOG_DEBUG, id=id)
	try:
		os.rmdir(path)
	except OSError, (errno, strerror):
		if errno != 39:
			debug("%s" % sys.exc_value, LOG_ERR)
	except:
		debug("%s: %s" % (sys.exc_type, sys.exc_value), LOG_ERR)

def mv(what, where):
	debug("mv(\"%s\" \"%s\")" % (what, where))
	try:
		os.rename(what, where)
	except:
		try:
			fpin = open(what,"r")
			fpout = open(where,"w+b")
			while 1:
				buf = fpin.read(1024*16)
				if len(buf) == 0: break
				fpout.write(buf)
			fpin.close()
			fpout.close()
			rm(what)
		except:
			debug("move failed: %s -> %s" % (what, where), LOG_WARNING)

def rm(file, id=None):
	debug("rm(\"%s\")" % (file), id=id)
	try:
		if os.path.exists(file):
			os.remove(file)
	except:
		pass

##
## START/QUIT
##
def makepid(fname):
	debug("makepid(\"%s\")" % (fname))

	if os.path.exists(fname):
		fp = open(fname, "r")
		pid=int(fp.readline().strip())
		fp.close

		if os.path.exists("/proc/%d" % pid):
			fp = open("/proc/%d/stat" % pid, "r")
  			pidstat = fp.readline().strip().split(" ")
			fp.close
			if pidstat[2] == "S": pidstat[2] = "Sleeping"
			elif pidstat[2] == "R": pidstat[2] = "Running"
			elif pidstat[2] == "T": pidstat[2] = "Stopped"
			pidstat = (pidstat[1][1:-1], pidstat[2])
			return pidstat
		else:
			rm(fname)
	try:
		fp = open(fname, "w+b")
		fp.write("%s\n" % os.getpid())
		fp.close()
	except:
		return ("Error", sys.exc_value)
	return

def cleanquit(signal=None, frame=None):
	debug("cleanquit()")
	rm(conf["main"]["pid"])
	conf["runtime"]["endtime"] = time.time()
	debug("Spam Filter runtime was %.3f" % (conf["runtime"]["endtime"]-conf["runtime"]["starttime"]), LOG_ERR)
	sys.stdout.flush()
	time.sleep(5)
	if conf["runtime"]["syslog"] == True:
		conf["runtime"]["syslog"] = False
		syslog.closelog()
	sys.exit(0)

##############################################################################
##
## TOOL FUNCTIONS
##
def timeme(timer=0, noshow=None, id=None, title="Timer"):
	if timer == 0: return time.time()
	timer = float(time.time())-float(timer)
	if timer < 0: timer = 0
	if not noshow: debug("\t%s: %.4f" % (title, timer), LOG_NOTICE, id=id)
	return float(timer)

def oneliner(value, id=None, noshow=None):
	if not noshow:
		dots=""
		if len(value) > 60: dots="..."
		debug("*oneliner(\"%s%s\")" % (re.sub("\n", " ", value[0:60]), dots), LOG_DEBUG, id=id)
	return re.sub(" + ", " ", re.sub("[\r\n\t]", " ", value))

def parse_addrs(addr, id=None):
	debug("*parse_addrs(\"%s\")" % addr, LOG_DEBUG, id=id)
	addr=re.sub(" ", "", re.sub(' ?[("].*?[)"]', "", addr.lower().strip()))
	if addr.startswith("<") or addr.endswith(">"):
		return [addr[addr.find("<")+1:addr.rfind(">")]]
	elif addr.find(","):
		return addr.split(",")
	else:
		return [addr]

# We could use already defined functions, like domainmatch(ptrs, domainsuffix)
# or cidrmatch(i, ipaddrs, cidr_length=32) ... good ideas, but does not do RegExp ;)
def is_listed(where,what,flags=re.IGNORECASE+re.MULTILINE,id=None,noshow=None):
	if what == None or where == None or len(what) < 1 or len(where) < 1: return
	if type(where) is str: where = [where]
	if type(what) is str: what = [what]

	if type(what) is dict:
		for a in what:
			tmp = is_listed(where,a,flags=flags,id=id,noshow=noshow)
			if tmp: return what[a]
	elif type(what[0]) is tuple:
		for a in what:
			tmp = is_listed(where,a[0],flags=flags,id=id,noshow=noshow)
			if tmp: return a[1]
	else:
		try:
			for haystack in where:
#				if not noshow: debug("is_listed(where=\"%s\")" % (haystack[:80]), LOG_DEBUG, id=id)
				for trap in what:
					try:
						if id: globaltmp[id] += 1
					except:
						pass
					if not noshow: debug("*is_listed(\t\"%s\")" % (trap), LOG_DEBUG, id=id)
					tmp = re.search(trap, haystack, flags)
					if tmp:
						if not noshow:
							debug("\t\tis_listed matched:", LOG_DEBUG, id=id)
							l = haystack[tmp.start():tmp.end()]
							if len(l) > 80: l = "%s..." % (l[:80])
							debug("\t\t%s" % l, LOG_DEBUG, id=id)

							l = trap
							if len(l) > 80: l = "%s..." % (l[:80])
							debug("\t\t%s" % l, LOG_DEBUG, id=id)

						return (trap, tmp.end()-tmp.start(), haystack[tmp.start():tmp.end()])
		except:
			debug("%s: %s" % (sys.exc_type, sys.exc_value), LOG_ERR)
			debug("FAILED: is_listed(%s, %s)" % (haystack, trap), LOG_ERR, id=id)
	return

##############################################################################
##
## Our Spam Testing Functions
##
def is_auth_mx(email, ip, id=None):
	debug("\t*is_auth_mx(\"%s\", \"%s\")" % (email, ip), LOG_INFO, id=id)
#
# Here is overview how is_auth_mx SHOULD work:
#
# Question: Is 195.67.27.196 authorized sender for gbg.hsb.se ?
#
# # host -t mx gbg.hsb.se
# gbg.hsb.se mail is handled by 10 mail.gbg.hsb.se.
# 
# # host mail.gbg.hsb.se
# mail.gbg.hsb.se has address 195.67.27.196
# 
# # host 195.67.27.196
# 196.27.67.195.in-addr.arpa domain name pointer 195-67-27-196.customer.telia.com.
#
# Answer: Yes, even reverse PTR is 'dynamic'.
#
#
#DNL##
#DNL## Here is sample of failure:
#DNL## Received: from fep01-app.kolumbus.fi (fep01-0.kolumbus.fi [193.229.0.41]) by SpamFilter with SMTP
#DNL## Received: from Nihonbashi (a81-197-15-170.elisa-laajakaista.fi [81.197.15.170]) by fep01-app.kolumbus.fi with SMTP
#DNL## From: user@elisanet.fi
#DNL##
#DNL## Nihonbashi has "Generated Dynamic DNS name" and is using
#DNL## fep01-app.kolumbus.fi as outgoing SMTP-server (yes, it is authorized for
#DNL## that). fep01-app.kolumbus.fi is not authorized sender for elisanet.fi,
#DNL## thou one can see that MX-fields are pointed to mx.kolumbus.fi That's why
#DNL## we need to do some serious checking for MX/SPF fields.
#DNL##
#DNL## And below is workaround:
#DNL## So we see that domains = elisanet.fi and MX of elisanet.fi = kolumbus.fi
#DNL## Now we have 2 domains, elisanet.fi and kolubus.fi. Next we need to check
#DNL## if host connected to us is authorized sender for those domains. And we see
#DNL## that 193.229.0.41 is in SPF for kolumbus.fi
#DNL## "v=spf1 ptr:elisa-laajakaista.fi ptr:elisa-dialup.fi ptr:elisa-mobile.fi ptr:kolumbus.fi ip4:193.229.0.32/27 mx ~all"
#DNL##
	try:
		domain=email.split("@")[1]
		user=email.split("@")[0]
	except:
		domain=email
		user="user"

	if domain[0] == "[" and domain[1:-1] == ip:
		debug("\t\tAuthMX (%s = %s)" % (domain, ip), LOG_NOTICE, id=id)
		return True

	domains = [domain]
	try:
		dns = spf.query("", "", "")
		dns_mx = dns.dns(domain, "MX")
		for mx in dns_mx:
			d = re.search("([^.\s]+?\.(\w)?(\w)?\w\w$)", mx[1])
			if d != None:
				t = d.group()
			else:
				t = mx[1]
			if t not in domains:
				domains.append(t)

		seen = []
		mxa = []
		for d in domains:
			dns_mx = dns.dns(d, "MX")
			for mx in dns_mx:
				if mx[1] not in seen:
					seen.append(mx[1])
					try:
						dns_a = dns.dns(mx[1], "A")[0]
						if dns_a not in mxa:
							mxa.append(dns_a)
					except IndexError:
						pass

		if len(mxa) > 0 and ip in mxa:
			debug("\t\tAuthMX (%s in %s)" % (ip, seen), LOG_NOTICE, id=id)
			return True

		for d in domains:
			dns_txt = dns.dns(d, "TXT")
			if dns_txt != []:
				debug("\t\tSPF query \"%s@%s\", txt = %s" % (user, d, dns_txt[0]), LOG_INFO, id=id)
				try:
					res = spf.query(i=ip, s="%s@%s" % (user, d), h="").check()
					if res[0] == 'pass':
						debug("\t\tAuthMX! %s (%s: %s)" % (res[0], res[1], res[2]), LOG_NOTICE, id=id)
						return True
				except:
					debug("\t\tSPF QUERY FAILED for %s: %s" % (d, dns_txt), LOG_NOTICE, id=id)
					return
	except DNS.DNSError, (errmsg):
		# Because DNS probably timed out, it is more safe to handle host as authenticated MX (skip DynDNS check)
		debug("\t\tAUTHMX! (by error: %s)" % (errmsg), LOG_NOTICE, id=id)
		return True
	debug("\tis_auth_mx = False", LOG_NOTICE, id=id)
	return

def rblcheck_ip(ip, id=None):
	debug("\t\trblcheck_ip(\"%s\")" % ip, LOG_NOTICE, id=id)
	try:
		dns = spf.query("", "", "")
		rblservers = conf["rbl"]["ipservers"]
		for rbl in rblservers:
			if conf["main"]["timeme"] is True: timer = timeme()
			tmp = dns.dns("%s.%s" % (spf.reverse_dots(ip), rbl), "A")
			if conf["main"]["timeme"] is True: debug("\t\t\t%ss - %s" % (str("%.4f") % timeme(timer, noshow=True), rbl), LOG_INFO, id=id)
			if not tmp: continue
			txt = dns.dns("%s.%s" % (spf.reverse_dots(ip), rbl), "TXT")
			if not txt:
				debug("\t\t\t* Found from %s" % (rbl), LOG_NOTICE, id=id)
				return "Blacklisted at %s with reason %s" % (rbl, tmp)
			if int(conf["main"]["verbose"]) < 2:
				debug("\t\t%s" % (txt)[0][0], LOG_NOTICE, id=id)
			else:
				debug("\t\t\t%s" % (txt), LOG_NOTICE, id=id)
			return txt[0][0]
	except DNS.DNSError, (errmsg):
		if errmsg not in ["Timeout"]: debug("DNS Error: %s (in rblcheck_ip)" % errmsg, LOG_ERR, id=id)
	return

def probcount(v, p, c=1, id=None):
	debug("probcount(%s, %s, %s)" % (v, p, c), LOG_DEBUG, id=id)
	if c < 1: c = 1
	return {"count": v["count"]+c, "prob": int(((v["prob"]*v["count"])+(p*c))/(v["count"]+c))}

##############################################################################
##
## Message handling
##
class HTMLStripper(htmllib.HTMLParser):
	def __init__(self):
#		debug("HTMLStripper.__init__()", LOG_DEBUG)
		self.bodytext = StringIO.StringIO()
		writer = formatter.DumbWriter(self.bodytext)
		htmllib.HTMLParser.__init__(self, formatter.AbstractFormatter(writer))

	def anchor_end(self):
#		debug("HTMLStripper.anchor_end()", LOG_DEBUG)
		if self.anchor:
			self.handle_data('')
			self.anchor = None

	def gettext(self):
#		debug("HTMLStripper.gettext()", LOG_DEBUG)
		return self.bodytext.getvalue()

def html_strip(htmlstr, id=None):
	if conf["main"]["timeme"] is True: timer = timeme()
	debug("*html_strip()", LOG_DEBUG, id=id)
	try:
		nohtml=HTMLStripper()
		htmlstr = re.sub("<font (color=.*? )?size=(\")?1(\")?>.*?</font>\n", "", re.sub("\\\\'", "\'", re.sub('\\\\"', '\"', htmlstr)))
		nohtml.feed(htmlstr)
		nohtml.close()
	except:
		if conf["main"]["timeme"] is True: timer = timeme()
		return(htmlstr, [])
	if conf["main"]["timeme"] is True: mail["timer"]["html_strip"] = str("%.4f") % timeme(timer, id=id)
	return (re.sub("\(image\)", "", re.sub("\xa0", "", nohtml.gettext())), nohtml.anchorlist)

def mimepart(part, lvl=0, param=None, id=None):
	if lvl == 0:
		debug("*mimepart()", LOG_DEBUG, id=id)
		if conf["main"]["timeme"] is True: timer = timeme()
	if not part.is_multipart() and part.get_content_type() != None:
		text = None
		if part.get_content_maintype() == "text":
			if part.get_content_subtype() == "plain" or part.get_content_subtype() == "html":
				text = part.get_payload(decode=True)
			else:
				if part.get_content_subtype() == "rfc822-headers":
					return
				debug("Unknown content type text/%s" % part.get_content_subtype(), LOG_NOTICE, id=id)
				return
				#text = part.get_payload(decode=True)
		if lvl>0:
			if text:
				return (part.get_content_maintype(), part.get_content_subtype(), "", param, text.strip())
			else:
				return (part.get_content_maintype(), part.get_content_subtype(), "", param, "")
		else:
			if text:
				return {0: (part.get_content_maintype(), part.get_content_subtype(), "", param, text.strip())}
			else:
				return {0: (part.get_content_maintype(), part.get_content_subtype(), "", param, "")}
		# Nothing to return
		return
	tree = {}
	sublvl=0
	tab="  "
	lvl+=1

	debug("\t%d.%d%s%s" % (lvl,sublvl,tab*lvl,part.get_content_type()), LOG_DEBUG, id=id)
	#tree[lvl*10+sublvl] = (part.get_content_type())
	if not part.get_payload():
		return tree
	for p in part.get_payload():
		ret = None
		if type(p) is str:
			if lvl > 1:
				return (part.get_content_maintype(), part.get_content_subtype(), "", param, part.get_payload().strip())
			return {10: (part.get_content_maintype(), part.get_content_subtype(), "", param, part.get_payload().strip())}
		if p.is_multipart():
			if p.get_param("x-spam-type") == "original":
				param="spam"
				tree = {}
			ret=mimepart(p, lvl, param, id=id)
			if ret:
				for r in ret:
					tree[r] = ret[r]
				continue
		else:
			sublvl += 1
			if p.get_param("x-spam-type") == "original":
				debug("\t%d.%d%s%s ( = original spam)" % (lvl,sublvl,tab*lvl,p.get_content_type()), LOG_DEBUG, id=id)
				msg=email.message_from_string(p.get_payload(decode=True))
				ret=mimepart(msg, lvl, param="spam", id=id)
			else:
				ret = mimepart(p, lvl, param, id=id)
		if ret:
			debug("\t%d.%d%s%s" % (lvl,sublvl,tab*lvl,p.get_content_type()), LOG_DEBUG, id=id)
			
			if p.get_param("x-spam-type"):
				tree = {}
			if type(ret) in [tuple]:
				tree[lvl*10+sublvl] = ret
			else:
				return ret
	if lvl == 0 and conf["main"]["timeme"] is True: mail["timer"]["mimepart"] = str("%.4f") % timeme(timer)
	return tree

##############################################################################
##
## Tests
##
def test_dofilter(mail):
	if conf["main"]["timeme"] is True: timer = timeme()
	found = False
	try:
		mail["todomain"] = mail["to"][0].split("@")[1]
		debug("test_dofilter(%s)" % (mail["todomain"]), LOG_NOTICE, id=mail["id"])
		mail["tests"].append("dofilter")
		found = is_listed(mail["todomain"], conf["filter"]["domains"], id=mail["id"])
		if found: debug("\t%s" % (found), LOG_NOTICE, id=mail["id"])
	except:
		debug("TEST_DOFILTER %s: %s" % (sys.exc_type, sys.exc_value), LOG_ERR, id=mail["id"], trace=True)
		save_vars(self.mail, "%s/%08d.var" % ("/tmp", self.id), id=self.id);
	if conf["main"]["timeme"] is True: mail["timer"]["test_dofilter"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (found, mail)

def test_connect(mail):
	if conf["main"]["timeme"] is True: timer = timeme()
	if mail["received"][1].has_key("dns"):
		debug("test_connect(%s, %s)" % (mail["received"][1]["ip"], mail["received"][1]["dns"]), LOG_NOTICE, id=mail["id"])
	else:
		debug("test_connect(%s)" % (mail["received"][1]["ip"]), LOG_NOTICE, id=mail["id"])
	mail["tests"].append("connect")

	found = None
	if mail["received"][1]["ip"] == mail["my"]["ip"] or mail["received"][1]["ip"] == "127.0.0.1":
		debug("\tSender is local (me)", LOG_DEBUG, id=mail["id"])
		mail["action"] = "Ignore"
		found = True

	if not found:
		debug("\t%s" % (mail["received"][1]["ip"]), LOG_DEBUG, id=mail["id"])
		if is_listed(mail["received"][1]["ip"], conf["connect"]["ignore_ip"], id=mail["id"]):
			debug("\tIgnored", LOG_NOTICE, id=mail["id"])
			mail["action"] = "Ignore"
			found = True
		elif is_listed(mail["received"][1]["ip"], conf["connect"]["allow_ip"], id=mail["id"]):
			debug("\tWhitelisted", LOG_NOTICE, id=mail["id"])
			mail["type"] = "connect"
			mail["action"] = "Accept"
			mail["reason"] = "Whitelisted"
			mail["detail"] = " IP: %s" % (mail["received"][1]["ip"])
			mail["reason_log"] = "IP"
			found = True
		elif is_listed(mail["received"][1]["ip"], conf["connect"]["block_ip"], id=mail["id"]):
			debug("\tBlacklisted", LOG_NOTICE, id=mail["id"])
			mail["type"] = "connect"
			mail["action"] = conf["connect"]["action"]
			mail["reason"] = "Blacklisted"
			mail["detail"] = " IP: %s" % (mail["received"][1]["ip"])
			mail["reason_log"] = "IP"
			found = True

	if not found and mail["received"][1].has_key("dns"):
		debug("\t%s" % (mail["received"][1]["dns"]), LOG_DEBUG, id=mail["id"])
		if is_listed(mail["received"][1]["dns"], conf["connect"]["ignore_dns"], id=mail["id"]):
			debug("\tIgnored DNS", LOG_NOTICE, id=mail["id"])
			mail["action"] = "Ignore"
			found = True
		elif is_listed(mail["received"][1]["dns"], conf["connect"]["allow_dns"], id=mail["id"]):
			debug("\tWhitelisted DNS", LOG_NOTICE, id=mail["id"])
			mail["type"] = "connect"
			mail["action"] = "Accept"
			mail["reason"] = "Whitelisted"
			mail["detail"] = " name: %s" % (mail["received"][1]["dns"])
			mail["reason_log"] = "DNS"
			found = True
		elif is_listed(mail["received"][1]["dns"], conf["connect"]["block_dns"], id=mail["id"]):
			debug("\tBlacklisted DNS", LOG_NOTICE, id=mail["id"])
			mail["type"] = "connect"
			mail["action"] = conf["connect"]["action"]
			mail["reason"] = "Blacklisted"
			mail["detail"] = " name: %s" % (mail["received"][1]["dns"])
			mail["reason_log"] = "DNS"
			found = True

	if found:
		debug("\t* MATCH *", LOG_NOTICE, id=mail["id"])
	if conf["main"]["timeme"] is True: mail["timer"]["test_connect"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (found, mail)

def test_helo(mail):
	if not mail["received"][1].has_key("helo"):
		return (None, mail)
	if conf["main"]["timeme"] is True: timer = timeme()
	debug("test_helo()", LOG_NOTICE, id=mail["id"])
	mail["tests"].append("helo")
	found = None

	if mail["received"][1]["ip"] == mail["my"]["ip"] or mail["received"][1]["ip"] == "127.0.0.1":
		debug("\tSender is local (me)", LOG_DEBUG, id=mail["id"])
		if conf["main"]["timeme"] is True: mail["timer"]["test_helo"] = str("%.4f") % timeme(timer, id=mail["id"])
		return (found, mail)
		
	for rec in mail["received"]:
		debug("\t%s" % (mail["received"][rec]["helo"]), LOG_INFO, id=mail["id"])

		if mail["received"][rec]["helo"] == mail["todomain"]:
			debug("\t\tMatch: %s = %s" % (mail["received"][rec]["helo"], mail["todomain"]), LOG_INFO, id=mail["id"])
			found = True
		elif mail["received"][rec]["helo"] == mail["my"]["ip"]:
			debug("\t\tMatch: %s = %s" % (mail["received"][rec]["helo"], mail["my"]["ip"]), LOG_INFO, id=mail["id"])
			found = True
		elif mail["my"].has_key("dns") and mail["received"][rec]["helo"] == mail["my"]["dns"]:
			debug("\t\tMatch: %s = %s" % (mail["received"][rec]["helo"], mail["my"]["dns"]), LOG_INFO, id=mail["id"])
			found = True

		if not conf["helo"]["recursive"]: break

	if found:
		mail["type"] = "helo"
		mail["action"] = conf["helo"]["action"]
		mail["reason"] = "Spam client detected"
		mail["detail"] = ""
		mail["reason_log"] = "%s" % (mail["received"][1]["helo"])

	if conf["main"]["timeme"] is True: mail["timer"]["test_helo"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (found, mail)

def test_samefromto(mail):
	if conf["main"]["timeme"] is True: timer = timeme()
	debug("test_samefromto(\"%s, %s\")" % (mail["from"][0], mail["to"][0]), LOG_NOTICE, id=mail["id"])
	mail["tests"].append("samefromto")
	found = None

	if mail["from"][0] == mail["to"][0]:
		debug("\tMatch: %s = %s" % (mail["from"][0], mail["to"][0]), LOG_INFO, id=mail["id"])
		found = True
	if found:
		mail["type"] = "samefromto"
		mail["action"] = conf["samefromto"]["action"]
		mail["reason"] = "Too much spams with this combination"
		mail["detail"] = ""
		mail["reason_log"] = " "

	if conf["main"]["timeme"] is True: mail["timer"]["test_samefromto"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (found, mail)

def test_accept(mail):
	if conf["main"]["timeme"] is True: timer = timeme()
	debug("test_accept()", LOG_NOTICE, id=mail["id"])
	mail["tests"].append("accept")
	found = None
	res = None
	seen = []
	accept = []

	globaltmp[mail["id"]] = 0
	for to in mail["to"]:
		for rec in mail["received"]:
			tmp = "%s:%s:%s" % (mail["received"][rec]["ip"],mail["from"][0],to)
			if tmp not in accept: accept.insert(0, tmp)

	for to in mail["to"]:
		for rec in mail["received"]:
			if mail["received"][rec].has_key("dns"):
				tmp = "%s:%s:%s" % (mail["received"][rec]["dns"],mail["from"][0],to)
				if tmp not in accept: accept.insert(0, tmp)

	for tmp in accept:
		res = is_listed(tmp, conf["accept"]["rules"], id=mail["id"])
		if res: break


	if res:
		debug("\t\t* MATCH *", LOG_DEBUG, id=mail["id"])
		found = True
		mail["type"] = "accept"
		mail["action"] = "accept"
		mail["reason"] = "Accepted"
		mail["detail"] = ": %s" % res[2]
		mail["reason_log"] = "%s" % res[2]

	debug("\tTests executed: %d / %d" % (globaltmp[mail["id"]], (len(accept)*len(conf["accept"]["rules"]))), LOG_INFO, id=mail["id"])
	del globaltmp[mail["id"]]
	if conf["main"]["timeme"] is True: mail["timer"]["test_accept"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (found, mail)

def test_block(mail):
	if conf["main"]["timeme"] is True: timer = timeme()
	debug("test_block()", LOG_NOTICE, id=mail["id"])
	mail["tests"].append("block")
	found = None
	res = None
	seen = []
	block = []

	globaltmp[mail["id"]] = 0
	for to in mail["to"]:
		for rec in mail["received"]:
			tmp = "%s:%s:%s" % (mail["received"][rec]["ip"],mail["from"][0],to)
			if tmp not in block: block.insert(0, tmp)

	for to in mail["to"]:
		for rec in mail["received"]:
			if mail["received"][rec].has_key("dns"):
				tmp = "%s:%s:%s" % (mail["received"][rec]["dns"],mail["from"][0],to)
				if tmp not in block: block.insert(0, tmp)

	for tmp in block:
		res = is_listed(tmp, conf["block"]["rules"], id=mail["id"])
		if res: break


	if res:
		debug("\t\t* MATCH *", LOG_DEBUG, id=mail["id"])
		found = True
		mail["type"] = "block"
		mail["action"] = "block"
		mail["reason"] = "Blocked"
		mail["detail"] = ": %s" % res[2]
		mail["reason_log"] = "%s" % res[2]

	debug("\tTests executed: %d / %d" % (globaltmp[mail["id"]], (len(block)*len(conf["block"]["rules"]))), LOG_INFO, id=mail["id"])
	del globaltmp[mail["id"]]
	if conf["main"]["timeme"] is True: mail["timer"]["test_block"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (found, mail)

def test_ipfromto(mail):
	if conf["main"]["timeme"] is True: timer = timeme()
	debug("test_ipfromto()", LOG_NOTICE, id=mail["id"])
	mail["tests"].append("ipfromto")
	found = None
	res = None
	seen = []
	ipfromto=[]

	globaltmp[mail["id"]] = 0
	users = 0
	for to in mail["to"]:
		users += 1
		for rec in mail["received"]:
			tmp = "%s:%s:%s" % (mail["received"][rec]["ip"],mail["from"][0],to)
			if tmp not in ipfromto: ipfromto.insert(0, tmp)
		if users >= conf["ipfromto"]["maxrcpt"]: break

	users = 0
	for to in mail["to"]:
		users += 1
		for rec in mail["received"]:
			if mail["received"][rec].has_key("dns"):
				tmp = "%s:%s:%s" % (mail["received"][rec]["dns"],mail["from"][0],to)
				if tmp not in ipfromto: ipfromto.insert(0, tmp)
		if users >= conf["ipfromto"]["maxrcpt"]: break

	for tmp in ipfromto:
		res = is_listed(tmp, conf["ipfromto"]["rules"], id=mail["id"])
		if res: break


	if res:
		debug("\t\t* MATCH *", LOG_DEBUG, id=mail["id"])
		found = True
		t=re.search("^(?:\(\?#).*?(?:\))", res[0])
		if t:
			test = res[0][3:t.end()-1]
				
		if test:
			mail["type"] = "ipfromto"
			mail["action"] = test
			mail["reason"] = "Blocked"
			mail["detail"] = " %s" % res[2]
			mail["reason_log"] = "%s" % res[2]

	debug("\tTests executed: %d / %d" % (globaltmp[mail["id"]], (len(ipfromto)*len(conf["ipfromto"]["rules"]))), LOG_INFO, id=mail["id"])
	del globaltmp[mail["id"]]
	if conf["main"]["timeme"] is True: mail["timer"]["test_ipfromto"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (found, mail)

def test_headers(mail):
	if conf["main"]["timeme"] is True: timer = timeme()
	debug("test_headers()", LOG_NOTICE, id=mail["id"])
	mail["tests"].append("headers")

	found=None
	globaltmp[mail["id"]] = 0
	for h in mail["header"]:
		if type(mail["header"][h]) is not str:
			globaltmp[mail["id"]] = globaltmp[mail["id"]] + 1
			continue
		debug("\t%s: %s" % (h, mail["header"][h]), LOG_DEBUG, id=mail["id"])
		res = is_listed("%s: %s" % (h, mail["header"][h]), conf["headers"]["rules"], noshow=True, id=mail["id"])
		if not res: continue
		found = True
	
		t=re.search("^(?:\(\?#).*?(?:\))", res[0])
		if t:
			test = res[0][3:t.end()-1]
		else:
			test = conf["headers"]["action"]

		if test:
			mail["action"] = test
			mail["type"] = "header"
			mail["reason"] = "Blocked by rule"
			mail["detail"] = ". Header %s" % (res[2])
			mail["reason_log"] = res[2]

		debug("\t\tResult: %s" % (test), LOG_NOTICE, id=mail["id"])
	debug("\tTests executed: %d / %d" % (globaltmp[mail["id"]], len(mail["header"])*len(conf["headers"]["rules"])), LOG_INFO, id=mail["id"])
	del globaltmp[mail["id"]]
	if conf["main"]["timeme"] is True: mail["timer"]["test_headers"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (found, mail)

def test_charset(mail):
	if conf["main"]["timeme"] is True: timer = timeme()
	debug("test_charset()", LOG_NOTICE, id=mail["id"])
	mail["tests"].append("charset")
	scan = None
	if mail["charset"]:
		globaltmp[mail["id"]] = 0
		debug("\tCharset: %s" % (mail["charset"]), LOG_INFO, id=mail["id"])
		scan = is_listed(mail["charset"], conf["charset"]["rules"], re.IGNORECASE, id=mail["id"])
		if scan:
			t=re.search("^(?:\(\?#).*?(?:\))", scan[0])
			if t:
				action = scan[0][3:t.end()-1]
				debug("\t* Match found with action %s" % (action), LOG_DEBUG, id=mail["id"])
			else:
				action = conf["charset"]["action"]
				debug("\t* Match found", LOG_DEBUG, id=mail["id"])
			if mail.has_key("bayesian"): del mail["bayesian"]
			mail["type"] = "charset"
			mail["action"] = action
			mail["reason"] = "Charset not accepted"
			mail["detail"] = " (%s)" % (scan[2])
			mail["reason_log"] = " %s" % (scan[2])
			scan = True
		del globaltmp[mail["id"]]
	if conf["main"]["timeme"] is True: mail["timer"]["test_charset"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (scan, mail)

def test_wordscan(mail):
	if conf["main"]["timeme"] is True: timer = timeme()
	debug("test_wordscan()", LOG_NOTICE, id=mail["id"])
	if mail["size"] > conf["wordscan"]["maxbodysize"]*1024:
		mail["tests"].append("!wordscan")
		return (None, mail)
	mail["tests"].append("wordscan")
	globaltmp[mail["id"]] = 0
	scan = None
#	if mail.has_key("RawSubject"):
	part = "Subject"
	debug("\tScanning %s: %s" % (part, mail["subject"]), LOG_NOTICE, id=mail["id"])
	scan = is_listed(mail["subject"], conf["wordscan"]["subject"], re.MULTILINE, id=mail["id"])
	if not scan:
		if mail.has_key("mime"):
			for a in mail["mime"]:
				tmp = re.sub("\r\n", "\n", mail["mime"][a][4])
				part = "%s%s" % (mail["mime"][a][1][0:1].upper(), mail["mime"][a][1][1:].lower())
				if mail["mime"][a][1] in ["html", "plain"]:
					if mail["mime"][a][1] in ["html"]:
						(tmp,links) = html_strip(tmp, id=mail["id"])

						if scan: break
						debug("\tScanning %d: %s (blockhtml)" % (a, part), LOG_NOTICE, id=mail["id"])
						scan = is_listed(tmp, conf["wordscan"]["blockhtml"], id=mail["id"])

						if scan: break
						debug("\tScanning %d: %s (links)" % (a, part), LOG_NOTICE, id=mail["id"])
						debug("\t\t%s" % (links), LOG_DEBUG, id=mail["id"])
						scan = is_listed(links, conf["wordscan"]["links"], LOG_NOTICE, id=mail["id"])

					if scan: break
					debug("\tScanning %d: %s" % (a, part), LOG_NOTICE, id=mail["id"])
					scan = is_listed(tmp, conf["wordscan"]["blockwords"], id=mail["id"])

					if mail["mime"][a][1] in ["plain"]:
						if scan: break
						debug("\tScanning %d: %s (stripped oneliner)" % (a, part), LOG_NOTICE, id=mail["id"])
						tmp = re.sub(" + ", " ", re.sub("[^a-zA-Z0-9\-:/,.%?!$@ \n]", " ", tmp))
						scan = is_listed(oneliner(tmp, id=mail["id"]), conf["wordscan"]["blockwords"], id=mail["id"], noshow=True)
						if scan: break

				else:
					debug("\tSkip %d: %s" % (a, part), LOG_INFO, id=mail["id"])
				if scan: break
		else:
			tmp = re.sub("\r\n", "\n", mail["raw"])
			part = "Raw message"
			debug("\tScanning %s" % (part), LOG_NOTICE, id=mail["id"])
			scan = is_listed(tmp, conf["wordscan"]["blockwords"], id=mail["id"])
	if scan:
		t=re.search("^(?:\(\?#).*?(?:\))", scan[0])
		if t:
			action = scan[0][3:t.end()-1]
		else:
			action = conf["wordscan"]["action"]

		debug("\t* Match found", LOG_DEBUG, id=mail["id"])
		if mail.has_key("bayesian"): del mail["bayesian"]
		mail["type"] = "wordblock"
		mail["action"] = action
		mail["reason"] = "Rejected content"
		mail["detail"] = ". %s matched as: %s" % (part, scan[2])
		mail["reason_log"] = "%s; %s" % (part, scan[2])
		scan = True
	debug("\tTests executed: %d" % (globaltmp[mail["id"]]), LOG_INFO, id=mail["id"])
	del globaltmp[mail["id"]]
	if conf["main"]["timeme"] is True: mail["timer"]["test_wordscan"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (scan, mail)

def test_dyndns(mail):
	debug("test_dyndns()", LOG_NOTICE, id=mail["id"])
	if conf["main"]["timeme"] is True: timer = timeme()
	found = None

	seen = []
	globaltmp[mail["id"]] = 0
	try:
		for r in mail["received"]:
			if conf["dyndns"]["recursive"] and len(seen) > 0:
				break
			if mail["received"][r]["ip"] in seen or mail["received"][r].has_key("dns") and mail["received"][r]["dns"] in seen: continue
			seen.append(mail["received"][r]["ip"])
			if mail["received"][r].has_key("dns"):
				seen.append(mail["received"][r]["dns"])
				debug("\t-> %s (%s)" % (mail["received"][r]["dns"], mail["received"][r]["ip"]), LOG_NOTICE, id=mail["id"])
			else:
				debug("\t-> %s" % (mail["received"][r]["ip"]), LOG_NOTICE, id=mail["id"])

			if mail["received"][r].has_key("dns") and is_listed(mail["received"][r]["dns"], conf["dyndns"]["ignore_authmx"], id=mail["id"]):
				continue

			if is_listed(mail["received"][r]["ip"], conf["dyndns"]["ignore_authmx"], id=mail["id"]):
				continue

			# if received-dns = sender domain
			if mail["received"][r].has_key("dns") and mail["from"][0].split("@")[1] == mail["received"][r]["dns"] and mail["from"][0].split("@")[0] != "mailer-daemon":
				mail["tests"].append("MX dns=domain")
				break
			# if received-dns = conf-known_authmx-dns
			elif mail["received"][r].has_key("dns") and is_listed(mail["received"][r]["dns"], conf["dyndns"]["known_authmx"], id=mail["id"]):
				mail["tests"].append("MX know dns by conf")
				debug("\t\tKnown AuthMX DNS %s" % (mail["received"][r]["dns"]), LOG_INFO, id=mail["id"])
				break
			# if received-ip = conf-known_authmx-ip
			elif is_listed(mail["received"][r]["ip"], conf["dyndns"]["known_authmx"], id=mail["id"]):
				mail["tests"].append("MX know ip by conf")
				debug("\t\tKnown AuthMX IP %s" % (mail["received"][r]["ip"]), LOG_INFO, id=mail["id"])
				break
			elif is_auth_mx(mail["from"][0], mail["received"][r]["ip"], id=mail["id"]):
				mail["tests"].append("Passed is_auth_mx")
				debug("\t\tIS_Auth_MX %s" % (mail["received"][r]["ip"]), LOG_NOTICE, id=mail["id"])
				break
			else:
				if mail["received"][r].has_key("dns") and (is_listed(mail["received"][r]["dns"], conf["dyndns"]["skip_dyndns"], id=mail["id"]) or is_listed(mail["received"][r]["dns"], conf["rbl"]["skip_dns"], id=mail["id"])):
					debug("\t\tSkip_DynDNS %s" % (mail["received"][r]["dns"]), LOG_INFO, id=mail["id"])
					continue
				if is_listed(mail["received"][r]["ip"], conf["dyndns"]["skip_dyndns"], id=mail["id"]) or is_listed(mail["received"][r]["ip"], conf["rbl"]["skip_ip"], id=mail["id"]):
					debug("\t\tSkip_DynDNS %s" % (mail["received"][r]["ip"]), LOG_INFO, id=mail["id"])
					continue
				if not mail["received"][r].has_key("dns"): continue
				
				dyncheck = is_listed(mail["received"][r]["dns"], conf["dyndns"]["rules"], id=mail["id"])
				mail["tests"].append("DYN %s" % (mail["received"][r]["dns"]))
				if dyncheck:
					mail["type"] = "dyndns"
					mail["action"] = conf["dyndns"]["action"]
					mail["reason"] = "Bad PTR-record in DNS"
					mail["detail"] = ", entry %s does not look like mail server." % (mail["received"][r]["dns"])
					mail["reason_log"] = "%s" % (mail["received"][r]["dns"])
					found = True
					break
	except:
		if sys.exc_value[0] not in ["DNS Timeout"]:
			debug("test_dyndns: %s: %s" % (sys.exc_type, sys.exc_value), LOG_ERR, trace=True)
			print "R: %s" % r
			print "END OF DEBUG"

	debug("\tTests executed: %d" % (globaltmp[mail["id"]]), LOG_INFO, id=mail["id"])
	del globaltmp[mail["id"]]
	if conf["main"]["timeme"] is True: mail["timer"]["test_dyndns"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (found, mail)

def test_rbl(mail):
	if conf["main"]["timeme"] is True: timer = timeme()
	debug("test_rbl()", LOG_NOTICE, id=mail["id"])
	found = None
	seen = []
	checked = []

	if conf["rbl"]["recursive"]:
		recs = mail["received"]
		debug("\tRecursive scan", LOG_INFO, id=mail["id"])
	else:
		recs = [1]
		debug("\tScan only connected host", LOG_INFO, id=mail["id"])
	globaltmp[mail["id"]] = 0
	rblcheck = None
	for r in recs:
		if mail["received"][r]["ip"] in seen: continue
		seen.append(mail["received"][r]["ip"])

		if mail["received"][r].has_key("dns"):
			debug("\t-> %s" % (mail["received"][r]["dns"]), LOG_NOTICE, id=mail["id"])
			if is_listed(mail["received"][r]["dns"], conf["rbl"]["skip_dns"], id=mail["id"]):
				debug("\t\tRBL skip %s" % (mail["received"][r]["dns"]), LOG_INFO, id=mail["id"])
				continue

		debug("\t-> %s" % (mail["received"][r]["ip"]), LOG_NOTICE, id=mail["id"])
		if is_listed(mail["received"][r]["ip"], conf["rbl"]["skip_ip"], id=mail["id"]):
			debug("\t\tRBL skip %s" % (mail["received"][r]["ip"]), LOG_INFO, id=mail["id"])
			continue

		try:
			rblcheck = rblcheck_ip(mail["received"][r]["ip"], id=mail["id"])
			mail["tests"].append("RBL %s" % (mail["received"][r]["ip"]))
		except:
			if sys.exc_value[0] not in ["DNS Timeout"]:
				debug("test_rbl: %s: %s" % (sys.exc_type, sys.exc_value), LOG_ERR, trace=True)
				print "R: %s" % r
				print "END OF DEBUG"

		if rblcheck: break

	if rblcheck:
		mail["type"] = "blacklisted"
		mail["action"] = conf["rbl"]["action"]
		mail["reason"] = rblcheck
		mail["detail"] = ""
		mail["reason_log"] = rblcheck
		found = True

	debug("\tTests executed: %d" % (globaltmp[mail["id"]]), LOG_INFO, id=mail["id"])
	debug("\t\tAction: %s" % (mail["action"]), LOG_NOTICE, id=mail["id"])
	del globaltmp[mail["id"]]
	if conf["main"]["timeme"] is True: mail["timer"]["test_rbl"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (found, mail)

def test_bayesian(mail):
	if conf["main"]["timeme"] is True: timer = timeme()
	debug("test_bayesian()", LOG_NOTICE, id=mail["id"])
	if mail["size"] > conf["bayesian"]["maxbodysize"]*1024:
		mail["tests"].append("!bayesian")
		return (True, mail)
	mail["tests"].append("bayesian")
	bayesiandb=None
	spambayes = None
	found = None
	try:
		mail["bayesian"] = { "scores": [], "tmp": [] }
		domaindb = "%s/%s/%s.db" % (conf["runtime"]["confpath"], "spamdb", domainrule(mail, "name", mail["todomain"]))
		usedomaindb=domainrule(mail, 'usedomaindb', conf["bayesian"]["usedomaindb"])
		if usedomaindb and os.path.exists(domaindb):
			spambayes = hammie.open(domaindb, useDB='dbm', mode='r')
 			hams = spambayes.bayes.nham
			spams = spambayes.bayes.nspam
			if min([hams, spams])+1 > int(domainrule(mail, "msgsneeded", conf["bayesian"]["msgsneeded"])):
				debug("\tUsing SpamDB %s" % domaindb, LOG_DEBUG, id=mail["id"])
			else:
				spambayes = None

		if not spambayes and conf["bayesian"]["commondb"] and os.path.exists(conf["bayesian"]["commondb"]):
			spambayes = hammie.open(conf["bayesian"]["commondb"], useDB='dbm', mode='r')
 			hams = spambayes.bayes.nham
			spams = spambayes.bayes.nspam
			if min([hams, spams])+1 > int(domainrule(mail, "msgsneeded", conf["bayesian"]["msgsneeded"])):
				debug("\tUsing CommonDB %s" % conf["bayesian"]["commondb"], LOG_DEBUG, id=mail["id"])
			else:
				spambayes = None

		if not spambayes:
			debug("\t*** Bayesian Disabled, condititions does not met.", LOG_NOTICE, id=mail["id"])
			return (None, mail)

		if mail.has_key("mime"):
			for a in mail["mime"]:
				part = "%s%s" % (mail["mime"][a][1][0:1].upper(), mail["mime"][a][1][1:].lower())
				if mail["mime"][a][1] in ["html", "plain"]:
					tmp = re.sub("\r\n", "\n", mail["mime"][a][4])
					if mail["mime"][a][1] in ["html"]:
						tmp = html_strip(tmp, id=mail["id"])[0]
					score = "%.2f" % (spambayes.score(tmp)*100)
					mail["bayesian"]["tmp"].append(float(score))
					mail["bayesian"]["scores"].append("%s %s (%s)" % (a, score, mail["mime"][a][1]))
					debug("\t%s. %s (%s)" % (a, score, part), LOG_NOTICE, id=mail["id"])
				else:
					mail["bayesian"]["tmp"].append(0)
		else:
			mail["tests"].append("!ERR-Bayesian")

		try:
			if len(mail["bayesian"]["tmp"]) == 1:
				mail["bayesian"]["score"] = mail["bayesian"]["tmp"][0]
			else:
				mail["bayesian"]["score"] = max(mail["bayesian"]["tmp"])
			del mail["bayesian"]["tmp"]
			debug("\tHiscore: %.2f%%" % (mail["bayesian"]["score"]), LOG_NOTICE, id=mail["id"])
		except:
			debug("TEST_BAYESIAN %s: %s (bayesian/tmp = %s)" % (sys.exc_type, sys.exc_value, mail["bayesian"]["tmp"]), LOG_ERR, id=mail["id"], trace=False)

		if mail["bayesian"]["score"] >= conf["bayesian"]["spampros"]:
			mail["type"] = "spam"
			mail["action"] = conf["bayesian"]["action"]
			mail["reason"] = "Bayesian filter detected this mail as spam"
			mail["detail"] = " by %.2f percent." % (mail["bayesian"]["score"])
			mail["reason_log"] = "%.2f%%" % (mail["bayesian"]["score"])
			found = True
		elif mail["bayesian"]["score"] > conf["bayesian"]["hampros"]:
			mail["type"] = "unsure"
			mail["action"] = conf["bayesian"]["unsure"]
			mail["reason"] = "Bayesian filter could not classify this message"
			mail["detail"] = ", mail looks like spam by %.2f percent" % (mail["bayesian"]["score"])
			mail["reason_log"] = "%.2f%%" % (mail["bayesian"]["score"])
		else:
			mail["type"] = "ham"
			mail["reason_log"] = "%.2f%%" % (mail["bayesian"]["score"])
	except:
		debug("TEST_BAYESIAN %s: %s" % (sys.exc_type, sys.exc_value), LOG_ERR, id=mail["id"], trace=True)

	if conf["main"]["timeme"] is True: mail["timer"]["test_bayesian"] = str("%.4f") % timeme(timer, id=mail["id"])
	return (found, mail)

def train_bayesian(mail, retrain=None):
# WORK #
	return
	if mail.has_key("hamflag") and mail["type"] not in ["virus", "ignore"]:
		train = "unsure"
	elif mail["type"] in ["ignore"]:
		return
	elif mail["type"] in ["trusted", "ham", "accept"]:
		train = "ham"
	elif mail["type"] in ["block", "blacklisted", "helo", "block", "spam", "wordblock"]:
		train = "spam"
	elif mail["type"] in ["virus"]:
		train = mail["type"]
	else:
		train = "unsure"

	if mail["size"] > conf["bayesian"]["maxtrainsize"]*1024:
		if domainrule(mail, 'dbtrain', conf["bayesian"]["dbtrain"]):
			debug("\t^-Bodysize > Bayesian MaxTrainSize", LOG_INFO, id=mail["id"])
		return

	if not os.path.exists("%s/%s" % (conf["runtime"]["confpath"], train)): mkdir("%s/%s" % (conf["runtime"]["confpath"], train))
	trainmbox = "%s/%s/%s" % (conf["runtime"]["confpath"], train, domainrule(mail, "name", mail["todomain"]))
	if not domainrule(mail, 'dbtrain', conf["bayesian"]["dbtrain"]) or train not in ["ham", "spam"]:
		if mail.has_key("raw") and mail.has_key("hamflag") or domainrule(mail, "savembox", conf["bayesian"]["savembox"]) or (train == "unsure" and domainrule(mail, "saveunsure", conf["bayesian"]["saveunsure"])):
			if do_lock(trainmbox, id=mail["id"]):
				mbox = open(trainmbox, "a")
				mbox.write(mail["raw"]+"\n")
				mbox.close()
				do_lock(trainmbox, unlock=True, id=mail["id"])

		if not domainrule(mail, 'dbtrain', conf["bayesian"]["dbtrain"]):
			debug("\t*** Bayesian Training Disabled", LOG_INFO, id=mail["id"])
		return

	if retrain: train = retrain
	if conf["main"]["timeme"] is True: timer = timeme()
	if not os.path.exists("%s/%s" % (conf["runtime"]["confpath"], "spamdb")): mkdir("%s/%s" % (conf["runtime"]["confpath"], "spamdb"))
	domaindb = "%s/%s/%s.db" % (conf["runtime"]["confpath"], "spamdb", domainrule(mail, "name", mail["todomain"]))
	debug("train_bayesian(%s)" % (train), LOG_NOTICE, id=mail["id"])
	if do_lock(domaindb, id=mail["id"]):
		try:
			sbtrain = hammie.open(domaindb, useDB='dbm', mode='c')
			hams = sbtrain.bayes.nham
			spams = sbtrain.bayes.nspam
			hamratio = float(domainrule(mail, 'ratio', conf["bayesian"]["ratio"]).split(':')[0])
			spamratio = float(domainrule(mail, 'ratio', conf["bayesian"]["ratio"]).split(':')[1])
			debug("\tTraining %s (has Ham/Spam: %s/%s) " % (domaindb, hams, spams), LOG_INFO, id=mail["id"])
			if not conf["bayesian"]["mimeparts"] or not mail.has_key("mime") or mail["mime"] == None:
				mail["mime"] = { 1: ( "raw", "", "", "", mail["raw"] )}
				tmpmime = True
			else:
				tmpmime = False

			for a in mail["mime"]:
				txt = None
				if mail["mime"][a][0] in ["text", "raw"]:
					txt = mail["mime"][a][4]
				if txt:
					if retrain:
						if train == "ham":
							sbtrain.untrain_spam(txt)
						elif train == "spam":
							sbtrain.untrain_ham(txt)
					if train == "ham":
						if (hams+1) < (spams*(hamratio/spamratio)+hamratio) and hams <= conf["bayesian"]["maxtrain"]:
							if conf["runtime"]["offline"]:
								debug("\tMessage trained as %s" % (train), LOG_NOTICE, id=mail["id"])
							else:
								sbtrain.train_ham(txt)
								if mail.has_key("raw") and domainrule(mail, "savembox", conf["bayesian"]["savembox"]) and do_lock(trainmbox, id=mail["id"]):
									mbox = open(trainmbox, "a")
									mbox.write(mail["raw"]+"\n")
									mbox.close()
									do_lock(trainmbox, unlock=True, id=mail["id"])
						else:
							debug("\t\tRatio %s does not allow training ham. Ham/Spam: %s/%s" % (domainrule(mail, "ratio", conf["bayesian"]["ratio"]), hams, spams), LOG_INFO, id=mail["id"])
					elif train == "spam":
						if (spams+1) < (hams*(spamratio/hamratio)+spamratio) and spams <= conf["bayesian"]["maxtrain"]:
							if conf["runtime"]["offline"]:
								debug("\tMessage trained as %s" % (train), LOG_NOTICE, id=mail["id"])
							else:
								sbtrain.train_spam(txt)
								if mail.has_key("raw") and domainrule(mail, "savembox", conf["bayesian"]["savembox"]) and do_lock(trainmbox, id=mail["id"]):
									mbox = open(trainmbox, "a")
									mbox.write(mail["raw"]+"\n")
									mbox.close()
									do_lock(trainmbox, unlock=True, id=mail["id"])
						else:
							debug("\t\tRatio %s does not allow training spam. Ham/Spam: %s/%s" % (domainrule(mail, "ratio", conf["bayesian"]["ratio"]), hams, spams), LOG_INFO, id=mail["id"])
			if tmpmime is True: del mail["mime"]
			sbtrain.store()
			do_lock(domaindb, unlock=True, id=mail["id"])
		except:
			debug("TRAIN_BAYESIAN %s: %s" % (sys.exc_type, sys.exc_value), LOG_WARNING, id=mail["id"], trace=True)

	if conf["main"]["timeme"] is True: mail["timer"]["train_bayesian"] = str("%.4f") % timeme(timer)
	return

##############################################################################
##
## MILTER
## This is runned for every SMTP Connection, and ONLY when Sendmail
## connects.
##
class SpamMilter(Milter.Milter):
	def maildef(self):
		return {
			"my": {
				"ip": "",
				"dns": "",
			},
			"smtpcmds": [ ],
			"from": [],
			"to": [],
			"todomain": "",
			"subject": "",
			"charset": "",
			"header": { },
			"size": 0,
			"received": {
				1: {
					"ip": None,
					"dns": None,
					"helo": None,
				}
			},
			"tests": [],
			"type": "",
			"timer": {},
		}

	def __init__(self):
		self.mail = self.maildef()
		self.id = Milter.uniqueID()
		self.mail["id"] = self.id
		debug("SpamMilter.__init__()", LOG_INFO, id=self.mail["id"])

		self.dns = spf.query("", "", "")

		self.tmpname = "%08d.tmp" % self.id
		try:
		## Temp file in DISK
			if not os.path.exists(conf["main"]["tmpdir"]): mkdir(conf["main"]["tmpdir"])
			self.tmp = open("%s/%s" % (conf["main"]["tmpdir"], self.tmpname),"w+b")
		except IOError, (errno, strerror):
			debug("Temp file failure (%s: %s)" % (errno, strerror), LOG_WARNING, id=self.id)
		except:
			debug("Temp file (%s) failure" % "%s/%s" % (conf["main"]["tmpdir"], self.tmpname), LOG_WARNING, id=self.id)
		self.mail["tmpfile"]=self.tmpname

	def _cleanup(self):
		debug("SpamMilter._cleanup()", LOG_INFO, id=self.id)
		if self.tmp: self.tmp.close()
		rm(self.tmp.name, id=self.id)
		if self.mail:
			if self.mail.has_key("raw"):
				if conf["main"]["timeme"] is True and self.mail["timer"].has_key("timepass"): self.mail["timer"]["timepass"] = str("%.4f") % timeme(self.mail["timer"]["timepass"], id=self.id, title="TTimer")
				if self.mail.has_key("mime"): del self.mail["mime"]
				if self.mail.has_key("header"): del self.mail["header"]
				if conf["main"]["savedir"] and not conf["runtime"]["offline"]:
					save_vars(self.mail, "%s/%08d.var" % (conf["main"]["savedir"], self.id), id=self.id);
			if not conf["runtime"]["offline"]: del self.mail
		sys.stdout.flush()
		return

###
### SMTP Commands
###
	def abort(self):
		debug("SpamMilter.abort()", LOG_INFO, id=self.id)
		self.mail = None
		self._cleanup()
		return Milter.CONTINUE

	def close(self):
		debug("SpamMilter.close()", LOG_INFO, id=self.id)
		if self.mail: self.mail["smtpcmds"].append("close")
		self._cleanup()
		return Milter.CONTINUE

	def connect(self,hostname,unused,hostaddr):
		debug("SpamMilter.connect(%s, %s)" % (hostname, hostaddr), LOG_INFO, id=self.id)
		self.mail["smtpcmds"].append("connect")
		self.mail["received"][1]["ip"] = hostaddr[0]
		self.mail["received"][1]["dns"] = hostname
		return Milter.CONTINUE

	def hello(self,hostname):
		debug("SpamMilter.hello(%s)" % (hostname), LOG_INFO, id=self.id)
		self.mail["smtpcmds"].append("hello")
		self.mail["received"][1]["helo"] = hostname
		self.reuse = self.mail["received"][1]
		return Milter.CONTINUE

	def envfrom(self,mailfrom,*vars):
		debug("SpamMilter.envfrom(\"%s\", %s)" % (mailfrom, vars), LOG_INFO, id=self.id)

		if not self.mail or "eom" in self.mail["smtpcmds"]:
			self._cleanup()
			oldid=self.id
			self.__init__()
			debug("Connection reused (New ID %s)" % (self.id), LOG_INFO, id=oldid)
			debug("Connection reused (old ID %s)" % (oldid), LOG_INFO, id=self.id)
			self.mail["received"][1] = self.reuse
			self.mail["smtpcmds"].append("reused")
		if conf["main"]["timeme"] is True: self.mail["timer"]["timepass"] = timeme()

		self.mail["smtpcmds"].append("envfrom")
		if mailfrom == "<>":
			if self.mail["received"][1].has_key("dns"):
				mailfrom = "<MAILER-DAEMON@%s>" % self.mail["received"][1]["dns"]
			else:
				mailfrom = "<MAILER-DAEMON@[%s]>" % self.mail["received"][1]["ip"]
		self.mail["from"] = parse_addrs(mailfrom, self.mail["id"])
		if not conf["runtime"]["offline"]:
			self.mail["my"]["ip"] = self.getsymval('{if_addr}')
			self.mail["my"]["dns"] = self.getsymval('{if_name}')
			self.mail["smtp"] = {"from": "", "to": []}
			if self.getsymval('{auth_type}'):
				self.mail["smtp"]["auth"] = self.getsymval('{auth_authen}')
			self.mail["smtp"]["from"] = "%s:%s:%s" % (self.getsymval('{mail_mailer}'), self.getsymval('{mail_host}'), self.getsymval('{mail_addr}'))
		return Milter.CONTINUE

	def envrcpt(self,rcpt,*vars):
		debug("SpamMilter.envrcpt(\"%s\")" % (rcpt), LOG_INFO, id=self.id)
		self.mail["smtpcmds"].append("envrcpt")
		if rcpt.startswith('<MAILER-DAEMON@'):
			debug("?To MAILER-DAEMON ?", LOG_WARNING, id=self.mail["id"])
		if len(self.mail["to"]) > 0 and rcpt not in self.mail["to"]:
			self.mail["to"].append(parse_addrs(rcpt, self.mail["id"])[0])
		else:
			self.mail["to"] = parse_addrs(rcpt, self.mail["id"])
		if not conf["runtime"]["offline"]:
			to="%s:%s:%s" % (self.getsymval('{rcpt_mailer}'), self.getsymval('{rcpt_host}'), self.getsymval('{rcpt_addr}'))
			if to not in self.mail["smtp"]["to"]:
				self.mail["smtp"]["to"].append(to)
		return Milter.CONTINUE

	def header(self,field,value):
		if "header" not in self.mail["smtpcmds"]: self.mail["smtpcmds"].append("header")
		if self.tmp and len(self.mail["header"]) == 0:
			debug("SpamMilter.header()", LOG_INFO, id=self.mail["id"])
			self.tmp.write("From %s %s\n" % (self.mail["from"][0], time.ctime()))
			self.mail["size"] = 0
			self.mail["subject"] = ""

		lfield = field.lower()
		while 1:
# Save everything as is
			if self.tmp: self.tmp.write("%s: %s\n" % (field, value))
# WORKME: Headers to drop
			if lfield in [ "x-spambayes-classification", "x-spam-level" ]:
				break
# If header already exists and not in "overwrite" list
			onelinerh = oneliner(value, id=self.mail["id"]).strip()
			if self.mail["header"].has_key(field) and lfield not in [ "subject" ]:
				if type(self.mail["header"][field]) is not list:
					tmp = self.mail["header"][field]
					del self.mail["header"][field]
					self.mail["header"][field] = [ tmp ]
				self.mail["header"][field].append(onelinerh)
			else:
				self.mail["header"][field] = onelinerh

			if lfield == "subject":
				self.mail["subject"] = self.mail["header"][field][:]
				break

			if lfield == "received":
				a = re.compile("(?:from ((?P<ip3>[\d\.]+)|(?P<helo>\S+)) (?:\(helo (?P<helo2>[\w\d\.]+?)\) )?((?:\(?(?:\w+@)?(?:\S+(?: )?)?)?(?:(?:\[)(?P<ip>[\d.]+?)(?:\](?:[: ].+?)?))\)? )?|(\((?P<ip2>[\d\.]+?)\) )?)(?:\(using .*?\))?by (?P<by>.+?)(?: \(.+?\))? (with|id) ").match(onelinerh.lower())
				if a == None:
					break
				reclen = len(self.mail["received"])+1
				self.mail["received"][reclen]=a.groupdict()
				if self.mail["received"][reclen]["ip"] == None and self.mail["received"][reclen]["ip3"] != None: self.mail["received"][reclen]["ip"] = self.mail["received"][reclen]["ip3"]
				del self.mail["received"][reclen]["ip3"]
				if self.mail["received"][reclen]["ip"] == None and self.mail["received"][reclen]["ip2"] != None: self.mail["received"][reclen]["ip"] = self.mail["received"][reclen]["ip2"]
				del self.mail["received"][reclen]["ip2"]
				if self.mail["received"][reclen]["ip"] == None:
					del self.mail["received"][reclen]
					break
				if self.mail["received"][reclen]["helo"] == None and self.mail["received"][reclen]["helo2"] != None: self.mail["received"][reclen]["helo"] = self.mail["received"][reclen]["helo2"]
				del self.mail["received"][reclen]["helo2"]

				try:
					dns = self.dns.dns("%s.in-addr.arpa" % spf.reverse_dots(self.mail["received"][reclen]["ip"]), "PTR")
					if len(dns) > 0 and type(dns) is list:
						self.mail["received"][reclen]["dns"] = dns[0]
				except DNS.DNSError, (errmsg):
					if errmsg in ["Timeout"]:
						debug("TIMEOUT SEEN")
					debug("DNS Error: %s (in header, received PTR)" % errmsg, LOG_ERR, id=self.mail["id"])
					pass
				break
			break
		return Milter.CONTINUE

	def eoh(self):
		debug("SpamMilter.eoh()", LOG_INFO, id=self.mail["id"])
		self.mail["smtpcmds"].append("eoh")
		if self.mail["to"][0][0:11] == "spamfilter@":
			return Milter.CONTINUE
		if conf["main"]["timeme"] is True: timer = timeme()

		toremove = []
		for r in self.mail["received"]:
			# Now we have received lines, make readable and remove stupid entries
			if self.mail["received"][r].has_key("by"):
				del self.mail["received"][r]["by"]
			for f in self.mail["received"][r].keys():
				if self.mail["received"][r][f] == None:
					del self.mail["received"][r][f]

			if not self.mail["received"][r].has_key("ip"):
				toremove.append(r)
				continue
			if r>1 and is_listed(self.mail["received"][r]["ip"], ["^127\.", "^192\.168\.", "^10\."], noshow=True):
				toremove.append(r)
				continue

			try:
				if self.mail["received"][r].has_key("dns"):
					if self.mail["received"][r]["dns"][0] == "[" or is_listed(self.mail["received"][r]["dns"], ["^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$"], noshow=True):
						del self.mail["received"][r]["dns"]
				if self.mail["received"][r].has_key("helo"):
					if self.mail["received"][r]["helo"][0] == "[":
						self.mail["received"][r]["helo"] = self.mail["received"][r]["helo"][1:-1]
#					if self.mail["received"][r].has_key("dns") and self.mail["received"][r]["dns"] == self.mail["received"][r]["helo"]:
#						del self.mail["received"][r]["helo"]
#					elif is_listed(self.mail["received"][r]["helo"], ["^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$"], noshow=True):
#						if self.mail["received"][r]["helo"] == self.mail["received"][r]["ip"]:
#							del self.mail["received"][r]["helo"]
#						elif is_listed(self.mail["received"][r]["helo"], ["^127\.", "^192\.168\.", "^10\."], noshow=True):
#							del self.mail["received"][r]["helo"]
			except:
				debug("%s: %s (do tests)" % (sys.exc_type, sys.exc_value), LOG_ERR, id=self.mail["id"], trace=False)
				print show_vars(self.mail)

		for r in toremove:
			del self.mail["received"][r]

		if conf["main"]["timeme"] is True: self.mail["timer"]["smtp_eoh"] = str("%.4f") % timeme(timer, id=self.mail["id"], noshow=True)
		return Milter.CONTINUE

	def body(self,chunk):
		debug("SpamMilter.body() (chunk size: %d)" % len(chunk), LOG_INFO, id=self.mail["id"])
		if self.tmp and self.mail["size"] == 0:
			self.tmp.write("\n")
		self.mail["size"] += len(chunk)
		if self.tmp:
			self.tmp.write(chunk)

		return Milter.CONTINUE

	def eom(self):
		debug("SpamMilter.eom()", LOG_INFO, id=self.mail["id"])
		self.mail["smtpcmds"].append("eom")
		action = {}

		if self.mail["to"][0][0:11] == "spamfilter@":
			debug("Log request from %s" % self.mail["from"][0], LOG_ERR, id=self.mail["id"])
			if conf["runtime"]["offline"]: return
# /*
# WORKME, user request
#			self.delrcpt(self.mail["to"][0])
#			self.addrcpt(self.mail["from"][0])
#			self.chgheader("MIME-Version", 1, "")
#			self.chgheader("Reply-To", 0, "")
#			self.chgheader("From", 0, "Spam Filter <abuse@%s>" % self.mail["my"]["dns"])
#			self.chgheader("Content-Type", 1, "text/plain")
#			self.chgheader("Subject", 1, "Spamfilter log for %s" % self.mail["from"][0])
#			logcmd = "grep '> <%s>' %s|LC_ALL=C sort -r|tail -500" % (self.mail["from"][0], conf["main"]["logfile"])
#			logdata = commands.getoutput(logcmd)
#			logdata += """
#
#List above is parsed from current log. Maximum of last 500 entries are shown.
#
#"""
#			if len(logdata) < 1:
#				logdata = "No entries found from current log."
#			self.replacebody(logdata)
#			return Milter.ACCEPT
# */
			return Milter.DISCARD

		# Authenticated sender
		if not conf["runtime"]["offline"] and self.mail["smtp"].has_key("auth"):
			debug("\tskip, authenticated", LOG_NOTICE, id=self.mail["id"])
			return Milter.ACCEPT

		#
		# Domain not found from filtered list
		(tests, self.mail) = test_dofilter(self.mail)

		if not tests:
			debug("\tskip, not filtered domain", LOG_NOTICE, id=self.mail["id"])
			return Milter.CONTINUE
		if conf["main"]["timeme"] is True: timer = timeme()
		todomain=self.mail["to"][0].split('@')[1]

		self.mail["rules"] = is_listed(todomain, conf["filter"]["rules"], id=self.mail["id"])
		if self.mail["rules"]: debug("\tRules: %s" % (self.mail["rules"]), LOG_NOTICE, id=self.mail["id"])

		subchar = []
		if self.mail["size"] == 0 and self.mail["subject"] == "":
			self.mail["type"] = "empty"
			return Milter.DISCARD

		try:
			self.tmp.seek(0)
			msg = email.message_from_file(self.tmp)
			(subj, subchar) = email.Header.decode_header(msg["subject"])[0]
			self.mail["subject"] = oneliner(stripUnprintable(subj), id=self.mail["id"], noshow=True)
			self.mail["rawsubject"] = oneliner(stripUnprintable(msg["subject"]), id=self.mail["id"], noshow=True)

			self.mail["raw"] = """%s""" % msg
		except:
# WORKME? If 'crashes' on email.message_from_file, save that tmp file into
# /tmp so we can take look of it later. Now we just need to pass mail
# without checking.
			debug("eom(): %s: %s" % (sys.exc_type, sys.exc_value), LOG_ERR, id=self.mail["id"], trace=False)
			if self.tmp:
				self.tmp.close()
				mv(self.tmp.name, "/tmp/%s" % self.tmpname)
			return Milter.CONTINUE
		if int(conf["main"]["verbose"]) < 2:
			debug("From: %s" % (self.mail["from"][0]), LOG_NOTICE, id=self.mail["id"])
			debug("To: %s" % (self.mail["to"]), LOG_NOTICE, id=self.mail["id"])
			debug("Subject: %s" % (self.mail["subject"]), LOG_NOTICE, id=self.mail["id"])
		self.mail["mime"] = mimepart(msg, id=self.mail["id"])

		charset = msg.get_charsets()
		charset.append(subchar)
		self.mail["charset"]=uniq(charset)

		# Default variables
		self.mail["type"] = "ham"
		self.mail["action"] = "pass"
		self.mail["reason"] = "passed"
		self.mail["detail"] = ""
		if conf["runtime"]["offline"]: matches = {}

		for test in tests:
			if test in ['disable']: continue
			try:
				debug("*call test_%s()" % (test), LOG_DEBUG, id=self.mail["id"])
				(ret, self.mail) = eval("test_"+test)(self.mail)
				if conf["runtime"]["offline"]:
					if ret:
						matches[test] = "%s: %s%s" % (self.mail["action"], self.mail["reason"], self.mail["detail"])
					else:
						matches[test] = "pass"
				if ret:
					if not conf["runtime"]["offline"]:
						debug("TEST MATCHES: %s" % (test), LOG_NOTICE, id=self.mail["id"])
						if test == "bayesian":
							self.mail["bayesiantype"] = self.mail["type"];
							if self.mail["type"] == "ham": continue
### NOTE TO SELF, Maybe this is good idea but
#   it should be configurable (on/off). Also it
#   should log as RBL_HAM, DynDNS_HAM or something...
#
# Disabled for now
#						# If message like HAM is blacklisted or dynamic, mark it as unsure.
#						elif self.mail.has_key("bayesiantype") and self.mail["bayesiantype"] == "ham" and self.mail["type"] in ['blacklist', 'blacklisted', 'dyndns']:
#							self.mail["action"] = "Flag"
#							self.mail["hamflag"] = True
					break
				else:
					if test == "bayesian": self.mail["bayesiantype"] = self.mail["type"]
				continue
					
			except:
				#debug("From: %s" % (self.mail["from"][0]), LOG_ERR, id=self.mail["id"])
				#debug("To: %s" % (self.mail["to"]), LOG_ERR, id=self.mail["id"])
				#debug("Subject: %s" % (self.mail["subject"]), LOG_ERR, id=self.mail["id"])
#				print show_vars(self.mail)
				#debug("Tests: %s" % tests, LOG_ERR)
				debug("Test: %s" % test, LOG_ERR)
				debug("%s: %s (do tests)" % (sys.exc_type, sys.exc_value), LOG_ERR, id=self.mail["id"], trace=False)
				traceback.print_exc(limit=None, file=sys.stderr)


# WORK
		self.mail["action"] = "%c%s" % (self.mail["action"][0:1].upper(), self.mail["action"][1:].lower())
		if self.mail["action"] not in ['Ignore']: # and not conf["runtime"]["offline"]:
			train_bayesian(self.mail)

# Conf: Detailed log
		if not self.mail.has_key("reason_log"): self.mail["reason_log"] = str("%s%s") % (self.mail["reason"], self.mail["detail"])
		if conf["main"]["timeme"] is True: self.mail["timer"]["tests"] = str("%.4f") % timeme(timer, noshow=True)
		if self.tmp: self.tmp.close()
		rm("%s/%s" % (conf["main"]["tmpdir"], self.tmpname), id=self.id)

		if conf["runtime"]["offline"]:
			debug("*** TEST STATUS ***", LOG_NOTICE, id=self.id)
			for a in matches:
				debug("\t%-8s:\t%s" % (a, matches[a]), LOG_NOTICE, id=self.id)
			debug("FINAL ACTION: %s" % (self.mail["action"]), LOG_NOTICE, id=self.id)

		if self.mail["action"] in ['Ignore']: return Milter.ACCEPT
		if not self.mail.has_key("bayesian"):
			self.mail["bayesian"] = { "score": "N/A" }
		if not self.mail["bayesian"].has_key("score"):
			self.mail["bayesian"]["score"] = "N/A"

		for to in self.mail["to"]:
			log = "%s" % time.strftime('%Y%m%d %H:%M:%S')
#			if conf["main"]["savedir"]:
#				log += " [%08d]" % self.mail["id"]
			log += " %s (%s: %s)" % (self.mail["action"].lower(), self.mail["type"], self.mail["reason_log"][:80])
			log += " %s" % (self.mail["bayesian"]["score"])
			log += " %d" % (int(self.mail["size"]))
			log += " %s" % (self.mail["received"][1]["ip"])
			if self.mail["received"][1].has_key("dns"):
				log += " (%s)" % (self.mail["received"][1]["dns"])
			else:
				log += " ()"
			log += " <%s> <%s> %s" % (self.mail["from"][0], to, self.mail["subject"])

			loglines.append(stripUnprintable(log))

#		if conf["stats"].has_key("driver") and conf["stats"]["driver"] == "mysql":
#			qupd = "UPDATE `%s` SET `msgs`=`msgs`+1" % (conf["stats"]["table"])
#			qupd += " WHERE domain='%s' AND date='%s'" % (to.split("@")[1], time.strftime('%Y%m%d'))
#			qupd += " AND action='%s' AND type='%s';" % (self.mail["action"].lower(), self.mail["type"].lower())
#			qins = "INSERT INTO `%s` SET `msgs`=1," % (conf["stats"]["table"])
#			qins += "domain='%s',date='%s'," % (to.split("@")[1], time.strftime('%Y%m%d'))
#			qins += "action='%s',type='%s';" % (self.mail["action"].lower(), self.mail["type"].lower())
#			statlines.append((qupd, qins, self.mail["id"]))
##		print self.mail["id"]
##		print to.split("@")[1]
##		print time.strftime('%Y%m%d')
##		print self.mail["action"].lower()
##		print self.mail["type"].lower()

		if conf["runtime"]["offline"]:
#TEMP#			Tlogger()
			return

		if self.mail["action"] in ['Reject']:
			conf["runtime"]["rrd"]["blocked"] += 1
		elif self.mail["action"] in ['Delete', 'Block']:
			conf["runtime"]["rrd"]["blocked"] += 1
		elif self.mail["action"] in ['Accept', 'Deliver', 'Pass']:
			conf["runtime"]["rrd"]["delivered"] += 1
		elif self.mail["action"] in ['Flag', 'Warn']:
#			if conf["filter"]["rules"].has_key(todomain) and conf["filter"]["rules"][todomain].has_key("rules") and "!flag" not in conf["filter"]["rules"][todomain]["rules"]:
			debug("! FLAGGED", LOG_NOTICE, id=self.mail["id"])
			conf["runtime"]["rrd"]["unsure"] += 1
		elif self.mail["type"] in ['virus']:
			debug("! VIRUS", LOG_NOTICE, id=self.mail["id"])
			conf["runtime"]["rrd"]["blocked"] += 1
			return Milter.DISCARD
		else:
			debug("! Unknown action ?", LOG_NOTICE, id=self.mail["id"])
			conf["runtime"]["rrd"]["delivered"] += 1

		if not domainrule(self.mail, 'watch', conf["main"]["watchmode"]):
			try: self.chgheader("X-%s-Reason" % (conf["main"]["name"]), 1, "%s; %s%s" % (test, self.mail["reason"], self.mail["detail"]))
			except: pass
			try: self.chgheader("X-%s-Scanned" % (conf["main"]["name"]), 1, time.strftime('%d.%m.%Y %H:%M:%S'))
			except: pass
			try: self.chgheader("X-%s-Tests" % (conf["main"]["name"]), 1, ", ".join(self.mail["tests"]))
			except: pass

			if conf["main"]["detailed"]: self.mail["reason"] += self.mail["detail"]

			if domainrule(self.mail, 'flagall') or self.mail["action"] in ['Flag', 'Warn']:
				if domainrule(self.mail, 'flagall'):
					debug("Notice, \"flagall\" used", LOG_NOTICE, id=self.mail["id"])
				test = re.search("{\w+}: ", self.mail["subject"], re.IGNORECASE)
				if not test and self.mail["type"].lower() != "ham":
#					try:
#						self.chgheader("X-Message-Flag", 1, "Follow up")
#						self.chgheader("X-Status", 1, "F")
#					except: pass
					try: self.chgheader("Subject", 1, "{%s}: %s" % (self.mail["type"].upper(),self.mail["subject"]))
					except: pass
				if self.mail.has_key("bayesian"):
					try:
						self.chgheader("X-Sspamm-Type", 1, "%s" % self.mail["type"])
						self.chgheader("X-Bayesian-Score", 1, "%s" % self.mail["bayesian"]["score"])
					except: pass
			elif self.mail["action"] in ['Reject']:
				debug("Milter.REJECT (500 5.7.1 - %s)" % self.mail["reason"], LOG_NOTICE, id=self.mail["id"])
				self.setreply("550", "5.7.1", self.mail["reason"])
				return Milter.REJECT
			elif self.mail["action"] in ['Accept', 'Deliver', 'Pass']:
				debug("Milter.ACCEPT", LOG_NOTICE, id=self.mail["id"])
				return Milter.ACCEPT
			elif self.mail["action"] in ['Delete', 'Block']:
				debug("Milter.DISCARD", LOG_NOTICE, id=self.mail["id"])
				return Milter.DISCARD
		debug("Milter.CONTINUE", LOG_NOTICE, id=self.mail["id"])
		return Milter.CONTINUE

###
### CHILD THREADS
###
def Tconfig(childname=None):
	global conffile

	files = [ ]
	cf = conffile
	if conffile[0] != "/":
		files.append("%s/%s" % (startdir, conffile))
		files.append("/etc/%s" % conffile)
		files.append("/etc/sspamm/%s" % conffile)
		files.append(None)

	for conffile in files:
		if conffile != None and os.access(conffile, os.R_OK):
			break

	if conffile == None:
		debug("FATAL: Can't find or read %s." % (cf), LOG_ERR)
		return

	while conf["runtime"]["endtime"] == 0:
		if not os.access(conffile, os.R_OK):
			debug("FATAL: Can't access %s." % (conffile), LOG_ERR)
			time.sleep(60)
			continue

		if conf["runtime"]["conftime"] < os.stat(conffile)[8]:
			if conf["runtime"]["conftime"] > 0:
				config_save()
			debug("Configuration reloaded", LOG_NOTICE)
			config_load(conffile)
			conf["runtime"]["conftime"] = os.stat(conffile)[8]
			conf["runtime"]["conffile"] = conffile
			if conf["main"]["sspammdir"]:
				conf["runtime"]["confpath"] = conf["main"]["sspammdir"]
			else:
				conf["runtime"]["confpath"] = conf["runtime"]["conffile"][0:conf["runtime"]["conffile"].rfind("/")+1]

			if conf["bayesian"]["commondb"] and conf["bayesian"]["commondb"][0] != "/": conf["bayesian"]["commondb"] = conf["runtime"]["confpath"]+"/"+conf["bayesian"]["commondb"]
			if conf["main"]["debugfile"]:
				if conf["main"]["debugfile"][0] != "/": conf["main"]["debugfile"] = conf["runtime"]["confpath"]+"/"+conf["main"]["debugfile"]
				dbgpath=conf["main"]["debugfile"][0:conf["main"]["debugfile"].rfind("/")+1]
				if not os.path.exists(dbgpath): mkdir(dbgpath)
			if conf["main"]["savedir"]:
				mkdir(conf["main"]["savedir"])
		else:
			time.sleep(5)
		if childname != "Configuration Loader":
			break
		time.sleep(1)
	return

def Tlogger(childname=None):
	if conf["main"]["logfile"] and conf["main"]["logfile"][0] != "/":
		conf["main"]["logfile"] = conf["runtime"]["confpath"]+"/"+conf["main"]["logfile"]
	logpath=conf["main"]["logfile"][0:conf["main"]["logfile"].rfind("/")+1]
	if not os.path.exists(logpath): mkdir(logpath)
	if childname == "Logger" and conf["main"]["logfile"]:
		logfile = open(conf["main"]["logfile"], "a")
		conf["runtime"]["logtime"] = os.stat(conf["main"]["logfile"])[8]
	while conf["runtime"]["endtime"] == 0:
		if conf["main"]["logfile"] and not conf["runtime"]["offline"]:
			if not os.path.exists(logpath): mkdir(logpath)
			if conf["main"]["logfile"][0] != "/":
				debug("Logfile %s is not with full path" % (conf["main"]["logfile"]), LOG_ERR)
				conf["main"]["logfile"] = conf["runtime"]["confpath"]+"/"+conf["main"]["logfile"]
				logpath=conf["main"]["logfile"][0:conf["main"]["logfile"].rfind("/")+1]
				if "sighup" not in loglines: loglines.append("sighup")
			elif logfile.name != conf["main"]["logfile"]:
				if "sighup" not in loglines: loglines.append("sighup")
				debug("Logfile name %s is not %s" % (logfile.name, conf["main"]["logfile"]), LOG_ERR)
			elif not os.path.exists(conf["main"]["logfile"]):
				if "sighup" not in loglines: loglines.append("sighup")
				debug("Creating new logfile %s" % (conf["main"]["logfile"]), LOG_ERR)
			elif conf["runtime"]["logtime"] < os.stat(conf["main"]["logfile"])[8]:
				if "sighup" not in loglines: loglines.append("sighup")
				debug("Logfile %s is modified" % (conf["main"]["logfile"]), LOG_ERR)

# TODO: Doesn't always see when logrotate happens!
		if len(loglines) == 0:
			if childname != "Logger": break
			time.sleep(1)
			continue

		while len(loglines) > 0:
			line = loglines.pop(0)
			if line == "sighup":
				if conf["runtime"]["offline"]: continue
				if conf["main"]["logfile"]:
					logfile.close()
					logfile = open(conf["main"]["logfile"], "a")
				continue

			if not conf["runtime"]["offline"]:
				logfile.write(line+"\n")
			else:
				print line
		sys.stdout.flush()
		if childname != "Logger": break
		logfile.flush()
		try:
			if conf["main"]["logfile"]: conf["runtime"]["logtime"] = os.stat(conf["main"]["logfile"])[8]
		except:
			if "sighup" not in loglines: loglines.append("sighup")

	if not conf["runtime"]["offline"]:
		if conf["main"]["logfile"] and logfile: logfile.close()
		debug("Logger quited", LOG_NOTICE)

# Thread that keeps mysql statistics updated
#def Tstats(childname):
#	if not conf["stats"].has_key("driver") or conf["stats"]["driver"] != "mysql" or childname != "Stats":
#		return
#	errno = 0
#	while True:
#		if errno > 0:
#			if errno not in [1050]:
#				debug("MySQL failure %d: %s" % (errno,errmsg), LOG_ERR)
#				cursor = None
#			break
#		try:
#			mydb=MySQLdb.Connect(host=conf["stats"]["host"], user=conf["stats"]["user"], passwd=conf["stats"]["pass"])
#			cursor = mydb.cursor()
#			mydb.select_db(conf["stats"]["database"])
#			cursor.execute("DESCRIBE %s" % conf["stats"]["table"])
#			errno = 0
#		except:
#			errno=sys.exc_value[0]
#			errmsg=sys.exc_value[1]
#		if errno == 0:
#			break
#		elif errno == 1044: # Access Denied
#			debug(errmsg, LOG_ERR)
#			cursor = None
#			break
#		elif errno == 1049: # Unknown database
#			try:
#				query = "CREATE DATABASE %s" % conf["stats"]["database"];
#				cursor.execute(query)
#				debug("Database %s created" % conf["stats"]["database"], LOG_NOTICE)
#				errno = 0
#			except:
#				errno=sys.exc_value[0]
#				errmsg=sys.exc_value[1]
#		elif errno == 1146: # Table does not exist
#			try:
#				query = "CREATE TABLE `%s` (`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY, `domain` VARCHAR(128), `date` INT UNSIGNED NULL, `action` VARCHAR(32), `type` VARCHAR(32), `msgs` MEDIUMINT NULL, INDEX (`domain`, `date`, `action`, `type`)) TYPE=MYISAM;" % conf["stats"]["table"]
#				cursor.execute(query)
#				debug("Table %s created" % conf["stats"]["table"], LOG_NOTICE)
#				errno = 0
#			except:
#				errno=sys.exc_value[0]
#				errmsg=sys.exc_value[1]
#		else:
#			debug("MySQL failure (%s): %s" % (errno, sys.exc_value[1]), LOG_ERR)
#			cursor = None
#		continue
#	if cursor: debug("MySQL is ready")
#
# Update MySQL queries in 5 sec intervals. Maybe there should be kind of
# local 'database' In memory, not just queries. It would be faster to update
# field values instead of increasing of one.
#
#	while conf["runtime"]["endtime"] == 0:
#		if len(statlines) == 0:
#			time.sleep(2)
#			continue
#		while len(statlines) > 0:
#			query = statlines.pop(0)
#			try:
#				ret = cursor.execute(query[0])
#				if ret:
#					debug("Executed MySQL query: %s" % (query[0]), LOG_INFO, id=query[2])
#				else:
#					ret = cursor.execute(query[1])
#					if ret:
#						debug("Executed MySQL query: %s" % (query[1]), LOG_INFO, id=query[2])
#					else:
#						debug("MySQL Update failed", LOG_ERR)
#			except:
#				debug("MySQL failure (%s): %s" % (errno, sys.exc_value[1]), LOG_ERR)
#				debug("Failed query was: %s" % (query[1]), LOG_ERR)
#	try:
#		if mydb: mydb.close()
#	except:
#		pass

## Thread that keeps RRD information updated, should update RRD info every 5 minutes or so.
def Trrd(childname):
	conf["runtime"]["rrd"] = { "delivered": 0, "unsure": 0, "blocked": 0, }
	if not os.path.exists("%s/sspamm.rrd" % conf["runtime"]["confpath"]):
		rrdtool.create("%s/sspamm.rrd" % conf["runtime"]["confpath"], "-s 300", 
			'DS:pass:GAUGE:600:-1:65535',
			'DS:flag:GAUGE:600:-1:65535',
			'DS:block:GAUGE:600:-1:65535',
			'RRA:AVERAGE:0.5:1:288',
			'RRA:AVERAGE:0.5:12:336',
			'RRA:AVERAGE:0.5:288:365',
		)

	if childname == "RRD":
		while conf["runtime"]["endtime"] == 0:
			ts=time.strftime('%Y%m%d %H:%M:%S')
			if ts[-2:] == "59": continue
			if ts[-2:] == "00" and ts[-4] in ["0", "5"]:
				timestamp=int(time.time())
				ham=conf["runtime"]["rrd"]["delivered"]
				unsure=conf["runtime"]["rrd"]["unsure"]
				spam=conf["runtime"]["rrd"]["blocked"]
				conf["runtime"]["rrd"] = { "delivered": 0, "unsure": 0, "blocked": 0, }
#				print "rrdupdate sspamm.rrd %s:%s:%s:%s" % (timestamp, ham, unsure, spam)
				sys.stdout.flush()
				try:
					rrdtool.update("%s/sspamm.rrd" % conf["runtime"]["confpath"], "%s:%d:%d:%d" % (timestamp, ham, unsure, spam))
				except:
					debug("RRD Update: %s: %s" % (sys.exc_type, sys.exc_value), LOG_ERR)

			time.sleep(59-int(ts[-2:]))

###
### MAIN
###
def main():
	global conf

	signal.signal(signal.SIGINT , cleanquit) # ^C
	mkdir(conf["main"]["tmpdir"])
	os.chdir(conf["main"]["tmpdir"])
	thread.start_new_thread(Tconfig,("Configuration Loader",))
	wtime = 0
	maxwtime = 20
	while conf["runtime"]["conftime"] == 0 and wtime < maxwtime:
		sys.stdout.flush()
		time.sleep(1)
		wtime += 1
	if conf["runtime"]["conftime"] == 0:
		debug("Couldn't load configuration file in %d seconds." % (maxwtime), LOG_ERR)
		sys.stdout.flush()
		return
	# Wait until configuration has been loaded
	while not conf["main"]["port"]:
		time.sleep(1)

	debug("Spam Filter started", LOG_ERR)
	sys.stdout.flush()

	tmp = makepid(conf["main"]["pid"])
	if tmp:
		if tmp[0] == "Error":
			debug("Couldn't create %s: %s" % (conf["main"]["pid"], tmp[1]), LOG_ERR)
		else:
			debug("PID file %s found for process %s (%s)." % (conf["main"]["pid"], tmp[0], tmp[1]), LOG_ERR)
		sys.stdout.flush()
		return

	thread.start_new_thread(Tlogger,("Logger",))
#	thread.start_new_thread(Tstats,("Stats",))
	thread.start_new_thread(Trrd,("RRD",))

	# Signals does not work with MilterModule, so they are here only as sample
	#signal.signal(signal.SIGHUP , sig_reload    ) # 1
	#signal.signal(signal.SIGQUIT, cleanquit     ) # 3
	#signal.signal(signal.SIGTRAP, signal.SIG_IGN) # 5
	#signal.signal(signal.SIGABRT, cleanquit     ) # 6
	#signal.signal(signal.SIGBUS , cleanquit     ) # 7
	#signal.signal(signal.SIGUSR1, sig_reload    ) # 10
	#signal.signal(signal.SIGUSR2, signal.SIG_IGN) # 12
	#signal.signal(signal.SIGTERM, cleanquit     ) # 15
	#signal.signal(signal.SIGINT , cleanquit     ) # ^C
	# Maximum runtime
	#signal.signal(signal.SIGALRM, cleanquit     )
	#signal.alarm(90)

	Milter.factory = SpamMilter
	Milter.set_flags(Milter.ADDRCPT + Milter.DELRCPT + Milter.ADDHDRS + Milter.CHGHDRS + Milter.CHGBODY)

	try:
		Milter.runmilter(conf["main"]["name"],conf["main"]["port"],300)
	except SystemExit:
		pass
	except:
		debug("%s: %s" % (sys.exc_type, sys.exc_value), LOG_ERR)
	cleanquit()

class test:
	def __init__(self, file, verbose = 1):
		if file.find(".") > 0:
			file=file[0:file.rfind(".")]
		if not os.path.exists(file):
			if os.path.exists("%s.var" % file):
				file = "%s.var" % file
			else:
				print "File %s not found!" % file
				sys.exit(2)

		# Load Configuration
		Tconfig()
		
		# Setup our debugging
		conf["runtime"]["offline"] = True
		conf["main"]["verbose"] = verbose
		conf["main"]["savedir"] = ""
		conf["main"]["tmpdir"] = "/tmp/sspamm"
		conf["main"]["watchmode"] = True

		# Load mail from file with variables
		self.mail = load_vars("%s" % file)
		# Open temp file and write raw message into it
		self.tmp = open("%s.tmp" % file, "w+b")
		self.tmp.write(self.mail["raw"])
		self.tmp.close()
		# Reopen tmp file as read-only and move to end
		# Now we should have system like when online
		self.tmp = open("%s.tmp" % file, "r")
		# Seek to end-of-file
		#self.tmp.seek(0,2)
		# Seek to begining-of-file
		self.tmp.seek(0)

	def feed2milter(self):
		m = SpamMilter()
		# Read connect information from variables, and simulate
		# SMTP-connection.
		if not self.mail["received"][1].has_key("dns"):
			self.mail["received"][1]["dns"] = "[%s]" % self.mail["received"][1]["ip"]
		m.connect(self.mail["received"][1]["dns"],None,[self.mail["received"][1]["ip"]])
		if self.mail["received"][1].has_key("helo"):
			m.hello(self.mail["received"][1]["helo"])
		else:
			m.hello(self.mail["received"][1]["dns"])
		if type(self.mail["from"]) is list:
			m.envfrom("<%s>" % self.mail["from"][0])
		else:
			m.envfrom("<%s>" % self.mail["from"])
		if type(self.mail["to"]) is list:
			for r in self.mail["to"]:
				m.envrcpt("<%s>" % r)
		else:
			m.envrcpt("<%s>" % self.mail["to"])
		self.tmp.seek(0)
		oline=""
		while 1:
			line=self.tmp.readline()
			if line[0:5] == "From ": continue

			if line[0] == "\t" or line[0] == " ":
				oline = oline+line
				tabbed=True
				continue
			elif oline == "":
				oline=line
			else:
				m.header(oline[0:oline.find(":")],oline[oline.find(":")+2:-1])
				oline=line
			if len(line) < 2: break
		m.eoh()
		# Feed only 1MB of message to milter, should we increase this?
		m.body(self.tmp.read(1024*1024))
		# Now we have done everything as in 'online'
		m.eom()
		m.close()
		if m.mail.has_key("raw"): del m.mail["raw"]
		#if m.mail.has_key("received"): del m.mail["received"]
		#if m.mail.has_key("from"): del m.mail["from"]
		#if m.mail.has_key("smtpcmds"): del m.mail["smtpcmds"]
		#if m.mail.has_key("timer"): del m.mail["timer"]
		#if m.mail.has_key("my"): del m.mail["my"]
		#if m.mail.has_key("mime"): del m.mail["mime"]
		#if m.mail.has_key("subject"): del m.mail["subject"]
	#	print show_vars(m.mail)
		self.tmp.close()
		rm(self.tmp.name)

	def run(self, arg=None):
		if arg == "test":
			self.feed2milter()
		elif arg == "spam":
			if self.mail["type"] != arg:
				train_bayesian(self.mail, retrain=arg)
				print "%s converted to %s" % (self.mail["type"], arg)
			else:
				print "Mail type already is %s" % (self.mail["type"])
		elif arg == "ham":
			if self.mail["type"] != arg:
				train_bayesian(self.mail, retrain=arg)
				print "%s converted to %s" % (self.mail["type"], arg)
			else:
				print "Mail type already is %s" % (self.mail["type"])
		sys.exit(0)

if __name__ == "__main__":
	tmp = None
	conf["runtime"]["starttime"] = time.time()
	startdir = os.getcwd()

	os.nice(5)
	locale.setlocale(locale.LC_CTYPE, locale.normalize('iso-8859-15'))
	if not sys.argv[1:]:
		main()
	else:
		if sys.argv[1:][0] == "dbtest":
			spambayes = None
			if len(sys.argv[1:]) > 1: spambayes = hammie.open(sys.argv[1:][1], useDB='dbm', mode='r')
			if len(sys.argv[1:]) == 3:
				if sys.argv[1:][2][-4:] == ".var":
					tmp = load_vars(sys.argv[1:][2])["raw"]
				else:
					tmp = open(sys.argv[1:][2], "r")
				print "%.2f" % (spambayes.score(tmp)*100)
			elif spambayes:
				print "Ham/Spam: %d/%d" % (spambayes.bayes.nham, spambayes.bayes.nspam)
			if type(tmp) is 'file': tmp.close()
		elif sys.argv[1:][0] == "regexp":
			if len(sys.argv) == 4:
				traps = [sys.argv[2:][0]]
				haystacks = [sys.argv[3:][0]]
			else:
				print "You need to use two arguments, needle and haystack"
				print "Like in:\n\tsspamm.py regexp '(?<!Spe)C[1i][a@]l[i1][ns]' 'Computer specialist'"
				sys.exit(1)

			for haystack in haystacks:
				for trap in traps:
					print "Testing: re.search('%s', '%s', re.I+re.M)" % (trap, haystack)
					tmp = re.search(trap, haystack, re.IGNORECASE+re.MULTILINE)
					if tmp:
						print "\tmatch:",haystack[tmp.start():tmp.end()]
		elif (sys.argv[1:][0] == "test" or sys.argv[1:][0] == "spam" or sys.argv[1:][0] == "ham") and sys.argv[2:]:
			if len(sys.argv) == 3:
				test(sys.argv[2:][0]).run(sys.argv[1:][0])
			else:
				test(sys.argv[2:][0], sys.argv[3:][0]).run(sys.argv[1:][0])
		else:
			print """
Without parameters spamfilter starts.

Parameters usage:
	dbtest	- Give bayesian database name and mail message (or .var file)
		  as parameter. Shows Bayesian score for message as scanned with
		  given database.
	spam	- Untrain messsage detected as ham and retrain it as spam
	ham	- Untrain messsage detected as spam and retrain it as ham
	regexp	- Tests regexp rules, give two parameters. Needle and haystack.
		  like: '(?<!Spe)C[1i][a@]l[i1][ns]' 'Computer specialist'
	test	- Give .var file as parameter, this does all same tests on
		  that saved mail as it would be done in online mode.
		  Runs on verbose debug mode. You can modify verbosity by adding
		  digit after filename, this is an optinal parameter (default=1).

"""
			sys.exit(1)
sys.exit(0)

### Nice?
#self.CID=randomchars(6,'0123456789abcdef')
