Summary: Semi's Spam Milter for Sendmail (python based)
Name: sspamm
Version: 2.8
Release: 1
License: BSD
Group: System Environment/Daemons
Source: https://sourceforge.net/projects/%{name}/repo/%{name}/%{version}/%{name}-%{version}.tgz
URL: http://%{name}.sf.net/
Packager: Sami-Pekka Hallikas <semi@hallikas.com>
Distribution: Custom
BuildRoot: %{_tmppath}/%{name}-rpmroot
BuildArch: noarch
AutoReq: 0
PreReq: /bin/sh /usr/bin/env /sbin/service /sbin/chkconfig perl make
Requires: sendmail, sendmail-cf, python >= 2.4.3, spambayes >= 1.1, pymilter >= 0.9.1, pydns >= 2.3.4, pyspf >= 2.0.5, lockfile >= 0.7, python-rrdtool
AutoProv: 0
Provides: spammilter, spamfilter

%description
Semi's Spam Milter (sspamm) is python based SPAM filter for Sendmail that
utilizes spambayes heurestic spam filtering and virus scanner (BitDefender,
not included).

%prep
%setup -q
# -c -n %{name}

%install
[ %{buildroot} == "/" ] || rm -rf %{buildroot}
mkdir -p %{buildroot}/etc/%{name}
mkdir -p %{buildroot}/usr/bin
mkdir -p %{buildroot}/etc/rc.d/init.d
mkdir -p %{buildroot}/etc/logrotate.d
mkdir -p %{buildroot}/var/run
mkdir -p %{buildroot}/var/log
mkdir -p %{buildroot}/etc/yum.repos.d

install -m 644 -o root -g mail %{name}.conf %{buildroot}/etc/%{name}/%{name}.conf
install -m 755 -o root -g root %{name}.py %{buildroot}/usr/bin/%{name}.py
install -m 755 -o root -g root %{name}.init %{buildroot}/etc/rc.d/init.d/%{name}
install -m 644 -o root -g root %{name}.logrotate %{buildroot}/etc/logrotate.d/%{name}
install -m 644 -o root -g root empty.db %{buildroot}/etc/%{name}/%{name}_common.db
install -m 644 -o root -g root %{name}.repo %{buildroot}/etc/yum.repos.d
install -m 644 -o root -g root test-mail.var %{buildroot}/etc/%{name}/test-mail.var
#touch %{buildroot}/etc/%{name}/debug.log
touch %{buildroot}/var/run/%{name}.pid
touch %{buildroot}/var/run/%{name}.sock
#touch %{buildroot}/var/log/%{name}.log

mkdir -p %{buildroot}/var/www/html/client
#install -m 644 -o root -g mail html/sspamm.php %{buildroot}/var/www/html/sspamm.php
#install -m 644 -o root -g mail html/client/* %{buildroot}/var/www/html/client/
install -m 755 -o root -g mail html/index.cgi %{buildroot}/var/www/html/index.cgi

%clean
[ %{buildroot} == "/" ] || rm -rf %{buildroot}

#
# Note: During update/upgrade of a package, the order is
# new-%pre, new-%post, old-%preun, old-%postun
# ... So INSTALL is done BEFORE remove
%pre
# $1: 1=install, 2=update
if [ "$1" = 2 ]; then
	/sbin/service %{name} stop > /dev/null 2>&1
fi

%post
# $1: 1=install, 2=update
if [ "$1" = 1 ]; then
	grep -q "^SELINUX=[ep]" /etc/sysconfig/selinux && chcon -t textrel_shlib_t /usr/lib/python2.4/site-packages/milter.so
	grep -q "FILTER..%{name}" /etc/mail/sendmail.mc
	if [ "$?" -ne 0 ]; then
		cat <<'EOF' >> /etc/mail/sendmail.mc
dnl INPUT_MAIL_FILTER(`%{name}', `S=local:/var/run/sspamm.sock')dnl
EOF
		make -C /etc/mail all > /dev/null 2>&1
		/etc/rc.d/init.d/sendmail condrestart > /dev/null 2>&1
	fi
#	/sbin/chkconfig --add %{name}
fi
#/sbin/service %{name} start > /dev/null 2>&1

%preun
# $1: 0=remove, 1=update
if [ "$1" = 0 ]; then
	/sbin/service %{name} stop > /dev/null 2>&1
	/sbin/chkconfig --del %{name}
# Keep repofile for reinstall
	mv /etc/yum.repos.d/%{name}.repo /etc/yum.repos.d/%{name}.repo.tmp
fi

%postun
# $1: 0=remove, 1=update
if [ "$1" = 0 ]; then
	/usr/bin/perl -pi -e "s|^INPUT_MAIL_FILTER\(\`sspamm\'|dnl INPUT_MAIL_FILTER\(\`sspamm\'|" /etc/mail/sendmail.mc
	make -C /etc/mail all > /dev/null 2>&1
	/etc/rc.d/init.d/sendmail condrestart > /dev/null 2>&1
# Keep repofile for reinstall
	mv -f /etc/yum.repos.d/%{name}.repo.tmp /etc/yum.repos.d/%{name}.repo
fi

%files
%defattr(-,root,mail)
%doc README

%config /etc/rc.d/init.d/%{name}
%config(missingok,noreplace) %verify(not md5 mode mtime size) /etc/logrotate.d/%{name}
%config(noreplace) %verify(not md5 mode mtime size) /etc/%{name}/%{name}.conf
%config(missingok,noreplace) %verify(not md5 mode mtime size) /etc/%{name}/%{name}_common.db
#%config(missingok,noreplace) %verify(not md5 mode mtime size) /etc/%{name}/debug.log
#%config(missingok,noreplace) %verify(not md5 mode mtime size) /var/log/%{name}.log
%config(missingok) %verify(not md5 mode mtime size) %ghost /var/run/%{name}.pid
%config(missingok) %verify(not md5 mode mtime size) %ghost /var/run/%{name}.sock
/usr/bin/*
/etc/sspamm/test-mail.var
#%config(missingok,noreplace) %verify(not md5 mode mtime size) /var/www/html/client/_ht*
/var/www/html/index.cgi
#/var/www/html/sspamm.php
#/var/www/html/client/index.php
#/var/www/html/client/favicon.ico
#/var/www/html/client/get_data.h
#/var/www/html/client/html.h
#/var/www/html/client/graph.h
%config(missingok,noreplace) %verify(not md5 mode mtime size) /etc/yum.repos.d/%{name}.repo

%changelog
* Wed May  5 2010 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 2.8)
- So much changes that I need to make diff of old version. Maybe it would be
  easier to call 3.0

* Thu May  9 2006 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 2.1)
- Final fixes/updates added before first public release of 2.x series

* Thu Mar  2 2006 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 2.0)
- Everything was fully rewrited from scratch!

* Sun Oct 23 2005 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 1.5)

* Fri Jan 14 2005 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 1.3)

* Wed Sep 29 2004 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 1.0)
- Today is my birthday, so what could be better present for me than 1.0
  version of SSpamM. :) ... So it is time to release v1.0.
  filter is stabile and I have been working (running) with it almost for one
  year now. Nowdays over 10.000 mails are going thru my filter every day.
- New feature: "Block IP" (under RBL). Personal blacklist.
- New featuer: "No Flag Domain" parameter. If some filtered domains don't
  want to see "UNSURE:" text in subject line. This was hardcoded in last
  release, but now it is config option.
- New feature: FromTo pairs ... Blocking and accepting (look for .conf for
  more information)
- Vscan is also one thread now. Mail is entered in virus scanner queue when
  it arrives, so only one vscan is on memory now. If there is need for
  multiple simultaneous scanning, please let me know.
- Logging has been moved to different thread, so there is no simultaneous
  writing in one destination. I've seen few times log line with another
  inside it.
- Some unprintable chars is removed from logged subject
- Major rewriting of: Domain/rule checking, word scan and bayesian scan.
- Now you can also block HTML code. Like 'script encoding'
- Debug parameter has been changed to verbose parameter.

* Wed Sep 15 2004 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 0.9.9 (Beta))
- New features: Blacklisting, Ignore by mail from/to.
- Some code added for future releases (SPF, debug, etc)
- LOTS of code cleanup. Now it should be more readable.

* Tue Aug 17 2004 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 0.9.8 (Beta))
- Summer is over. Has been long time when I had not updated Sourceforge,
  so it is time to update with new version. I'm planning to put also
  'work in progress' version to webpage, and automatic update for that.
  But let's see that later...
- Well, I'm planning to move on Alpa state. Filter seems to be quite OK.
  'thou there is some problems when high count of mails come in at same
  time. When all those goes to Virus Scanner, scanner would kill system
  quite easily. Only way to prevent is to add sender/received to
  block/accept mode, so no scanning is done for those mails.
  ... Well, that is not correct way to fix this. But this is only minor
  problem, and I'm planning to do something to this when I have more time.

* Mon Jun 28 2004 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 0.9.3 (Beta))
- Bug/feature fixes
- init script fixes
- Added ham+word size. So big messages are trusted as HAM, also limit some
  words scans.
- Added some code to prevent total crash of code. If one test fails in error
  should code skip it.
- Disabled 'stripped oneliner' scan... It may be too powerfull if used with
  some regexp wordblocks.

* Mon Jun 15 2004 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 0.9.1 (Beta))
- Subject will be converted from MIME to 8bit clean before printing to log.
- Working with improved Spam Scan code with RegExp "block word" lists.
  This SpamScan2 code is checked after spambayes, if it had no spam/bounce
  hit.
- SpamScan2 handles also multipart messages. Those splitted and last text
  type message is considered as body of mail. All HTML messages are
  translated into plain text before processing.
- "block word" scans entire message thru "part by part", and stops for first
  match. Parts to scan is: HTML Links, Subject, Body, Body as "one line",
  Body as "one line" with only [a-zA-Z0-9 ].

* Mon May 24 2004 Sami-Pekka Hallikas <semi@hallikas.com>
- Messages with 0 bytes body should be blocked, Who are sending messages
  without text, or even subject lines?

* Fri May 21 2004 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 0.8.2 (Beta))
- Too much to do, to little time to do it. Well, long time since I had some
  time for filter. But now I try make few improvements.
- Fix/Feature: Bounced messages are saved + deleted by default. There is no
  need to pass them thru.

* Wed Apr 28 2004 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 0.8.1 (Beta))
- Fix: Sometimes there is same virus multiple times in same message. Edited
  so only one "hit" is shown.

* Thu Apr 22 2004 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 0.8 (Beta))
- Quick jump from v0.2 to v0.8. It seems that sspamm is stabile enough to be
  more near version 1 release.
- Fix: strip extra spaces in log (virus infection had extra spaces)
- Feature: Client mail (outgoing, passthru) should not be checked. So we are
  checking "domain ignore" also as "from domain", not only "to domain".
  Maybe I should rewrite this filter/watch/ignore domain to be more like
  "accept/block fromuser/touser".

* Wed Apr 21 2004 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 0.2 (Beta))
- Wohaa, about 70% of all code got rewrited, I modified 'flowing' quite
  much, to make it easier to handle. No more mailbox or log functions, just
  modify one place and it handles all.

* Thu Apr  1 2004 Sami-Pekka Hallikas <semi@hallikas.com> (Version: 0.01 (Beta))
- Everything is working just fine. Now I just need to recode source for
  public release. Maybe I need to find way to configure sspamm with
  external configuration file, there is too many variables hardcoded.
